/***************************************************************************
                          interface_callbacks_variables.cpp  -  description
                             -------------------
    begin                : Sat Jan 20 2001
    copyright            : (C) 2001 by c0del4rvi4
    email                : reduz@anime.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "interface.h"

void Interface::on_spinbutton_variables_tempo_changed() {

	if (variables_page_updating_in_progress) return;

	song->initial_variables.tempo=spinbutton_variables_tempo->get_value_as_int();
}
void Interface::on_spinbutton_variables_speed_changed() {

	if (variables_page_updating_in_progress) return;

	song->initial_variables.speed=spinbutton_variables_speed->get_value_as_int();
}
void Interface::on_spinbutton_variables_glb_volume_changed() {

	if (variables_page_updating_in_progress) return;

	song->initial_variables.global_volume=spinbutton_variables_glb_volume->get_value_as_int();
}
void Interface::on_spinbutton_variables_mix_volume_changed() {

	if (variables_page_updating_in_progress) return;

	song->variables.mixing_volume=spinbutton_variables_mix_volume->get_value_as_int();
}
void Interface::on_spinbutton_variables_stereo_separation_changed() {

	if (variables_page_updating_in_progress) return;

	song->variables.stereo_separation=spinbutton_variables_stereo_separation->get_value_as_int();
}


void Interface::on_checkbutton_variables_old_effects_clicked(){

	if (variables_page_updating_in_progress) return;

	song->variables.old_effects=checkbutton_variables_old_effects.get_active();
}

void Interface::on_checkbutton_variables_compat_gxx_clicked(){

	if (variables_page_updating_in_progress) return;

	song->variables.compatible_gxx=checkbutton_variables_compat_gxx.get_active();

}

void Interface::on_radiobutton_variables_control_instruments_clicked() {

	if (variables_page_updating_in_progress) return;

	realtime_keyboard.instrument_stop_all();
	realtime_keyboard.sample_stop_all();
      	player->play_stop();

	variables_lock->grab();
	song->set_instrument_mode();
	variables_lock->release();

        update_clist_instrments_names();
	update_selected_instrument_info();
}

void Interface::on_radiobutton_variables_control_samples_clicked() {

	if (variables_page_updating_in_progress) return;

	realtime_keyboard.instrument_stop_all();
	realtime_keyboard.sample_stop_all();
      	player->play_stop();

	variables_lock->grab();
	song->set_sample_mode();
	variables_lock->release();

        update_clist_instrments_names();
	update_selected_instrument_info();
}

void Interface::on_radiobutton_variables_playback_stereo_clicked() {

	if (variables_page_updating_in_progress) return;

	song->variables.use_stereo=true;
}

void Interface::on_radiobutton_variables_playback_mono_clicked() {

	if (variables_page_updating_in_progress) return;

	song->variables.use_stereo=false;
}

void Interface::on_radiobutton_variables_slides_linear_clicked() {

	if (variables_page_updating_in_progress) return;

	song->variables.use_linear_slides=true;
}

void Interface::on_radiobutton_variables_slides_amiga_clicked() {

	if (variables_page_updating_in_progress) return;

	song->variables.use_linear_slides=false;
}

void Interface::on_text_variables_changed() {

	if (variables_page_updating_in_progress) return;

	if (text_variables_message.get_length()>7999) {

               	text_variables_message.set_point(7998);
		text_variables_message.delete_text(7999,-1);
	}

	song->variables.message=text_variables_message.get_chars(0,-1);


}