/***************************************************************************
                          interface_initialize_widgets.cpp  -  description
                             -------------------
    begin                : Thu May 3 2001
    copyright            : (C) 2001 by Juan Linietsky
    email                : reduz@anime.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "interface.h"
#include "gdk--/pixmap.h"
#include "../icons/bw.xpm"
#include "../icons/ff.xpm"
#include "../icons/play_cur.xpm"
#include "../icons/stop.xpm"
#include "../icons/play.xpm"
#include "../icons/play_pat.xpm"
#include "../icons/help.xpm"
#include "../icons/file.xpm"


void Interface::initialize_widgets() {

	/** DONT READ THIS! YOU MIGHT GO INSANE!! GALHGRLALBLARRLBARLBARBLRBLA */


   #define connect_to_method(widget,parent,callback) widget##.connect(slot(parent,##callback##))


   spinbutton_samples_def_volume_adj = new Gtk::Adjustment(0, 0, 64, 1, 10, 10);
//   spinbutton_samples_def_volume = new Gtk::SpinButton(*spinbutton_samples_def_volume_adj, 1, 0);
   spinbutton_samples_def_volume = new Scroll_Bar(*spinbutton_samples_def_volume_adj);
   spinbutton_samples_glb_volume_adj = new Gtk::Adjustment(1, 0, 64, 1, 10, 10);
   spinbutton_samples_glb_volume = new Scroll_Bar(*spinbutton_samples_glb_volume_adj);
   spinbutton_samples_def_pan_adj = new Gtk::Adjustment(1, 0, 64, 1, 10, 10);
   spinbutton_samples_def_pan = new Scroll_Bar(*spinbutton_samples_def_pan_adj);
   spinbutton_samples_vibrato_speed_adj = new Gtk::Adjustment(1, 0, 64, 1, 10, 10);
   spinbutton_samples_vibrato_speed = new Scroll_Bar(*spinbutton_samples_vibrato_speed_adj);
   spinbutton_samples_vibrato_depth_adj = new Gtk::Adjustment(1, 0, 32, 1, 10, 10);
   spinbutton_samples_vibrato_depth = new Scroll_Bar(*spinbutton_samples_vibrato_depth_adj);
   spinbutton_samples_vibrato_rate_adj = new Gtk::Adjustment(1, 0, 255, 1, 10, 10);
   spinbutton_samples_vibrato_rate = new Scroll_Bar(*spinbutton_samples_vibrato_rate_adj);
   radiobutton_samples_waveform_saw = new Gtk::RadioButton("Saw");
   radiobutton_samples_waveform_sine = new Gtk::RadioButton( "Sine");
   radiobutton_samples_waveform_sine->set_group(radiobutton_samples_waveform_saw->group());
   radiobutton_samples_waveform_square = new Gtk::RadioButton( "Square");
   radiobutton_samples_waveform_square->set_group(radiobutton_samples_waveform_saw->group());
   radiobutton_samples_waveform_random = new Gtk::RadioButton( "Random");
   radiobutton_samples_waveform_random->set_group(radiobutton_samples_waveform_saw->group());

   spinbutton_samples_base_note_adj = new Gtk::Adjustment(1, 0, Note::NOTES, 1, 12, 12);
   spinbutton_samples_base_note = new Gtk::SpinButton(*spinbutton_samples_base_note_adj, 1, 0);
   spinbutton_samples_finetune_adj = new Gtk::Adjustment(0, -128, 127, 1, 10, 10);
   spinbutton_samples_finetune = new Gtk::SpinButton(*spinbutton_samples_finetune_adj, 1, 0);

   spinbutton_samples_speed_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_samples_speed = new Gtk::SpinButton(*spinbutton_samples_speed_adj, 1, 0);
   spinbutton_samples_loop_begin_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_samples_loop_begin = new Gtk::SpinButton(*spinbutton_samples_loop_begin_adj, 1, 0);
   spinbutton_samples_loop_end_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_samples_loop_end = new Gtk::SpinButton(*spinbutton_samples_loop_end_adj, 1, 0);
   spinbutton_samples_susloop_begin_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_samples_susloop_begin = new Gtk::SpinButton(*spinbutton_samples_susloop_begin_adj, 1, 0);
   spinbutton_samples_susloop_end_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_samples_susloop_end = new Gtk::SpinButton(*spinbutton_samples_susloop_end_adj, 1, 0);

   radiobutton_instruments_nna_note_cut = new Gtk::RadioButton( "Note Cut");
   radiobutton_instruments_nna_note_continue = new Gtk::RadioButton( "Continue");
   radiobutton_instruments_nna_note_continue->set_group(radiobutton_instruments_nna_note_cut->group());
   radiobutton_instruments_nna_note_off = new Gtk::RadioButton( "Note Off	");
   radiobutton_instruments_nna_note_off->set_group(radiobutton_instruments_nna_note_cut->group());	
   radiobutton_instruments_nna_note_fade = new Gtk::RadioButton( "Note Fade");
   radiobutton_instruments_nna_note_fade->set_group(radiobutton_instruments_nna_note_cut->group());	

   radiobutton_instruments_dca_disabled = new Gtk::RadioButton( "Disabled	");
   radiobutton_instruments_dca_note = new Gtk::RadioButton( "Note");
   radiobutton_instruments_dca_note->set_group(radiobutton_instruments_dca_disabled->group());
   radiobutton_instruments_dca_sample = new Gtk::RadioButton( "Sample");
   radiobutton_instruments_dca_sample->set_group(radiobutton_instruments_dca_disabled->group());
   radiobutton_instruments_dca_disabled_instrument = new Gtk::RadioButton( "Instrument");
   radiobutton_instruments_dca_disabled_instrument->set_group(radiobutton_instruments_dca_disabled->group());

   radiobutton_instruments_dca_note_fade = new Gtk::RadioButton( "Note Fade");

   radiobutton_instruments_dca_note_off = new Gtk::RadioButton( "Note Off");
   radiobutton_instruments_dca_note_off->set_group(radiobutton_instruments_dca_note_fade->group());
   radiobutton_instruments_dca_note_cut = new Gtk::RadioButton( "Note Cut");
   radiobutton_instruments_dca_note_cut->set_group(radiobutton_instruments_dca_note_fade->group());

   spinbutton_instruments_volume_envelope_loop_begin_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_instruments_volume_envelope_loop_begin = new Gtk::SpinButton(*spinbutton_instruments_volume_envelope_loop_begin_adj, 1, 0);
   spinbutton_instruments_volume_envelope_loop_end_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_instruments_volume_envelope_loop_end = new Gtk::SpinButton(*spinbutton_instruments_volume_envelope_loop_end_adj, 1, 0);
   spinbutton_instruments_volume_envelope_susloop_begin_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_instruments_volume_envelope_susloop_begin = new Gtk::SpinButton(*spinbutton_instruments_volume_envelope_susloop_begin_adj, 1, 0);
   spinbutton_instruments_volume_envelope_susloop_end_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_instruments_volume_envelope_susloop_end = new Gtk::SpinButton(*spinbutton_instruments_volume_envelope_susloop_end_adj, 1, 0);
   spinbutton_instruments_global_volume_adj = new Gtk::Adjustment(0, 0, 128, 1, 10, 10);
   spinbutton_instruments_global_volume = new Gtk::SpinButton(*spinbutton_instruments_global_volume_adj, 1, 0);
   spinbutton_instruments_volume_fadeout_adj = new Gtk::Adjustment(0, 0, 256, 1, 10, 10);
   spinbutton_instruments_volume_fadeout = new Gtk::SpinButton(*spinbutton_instruments_volume_fadeout_adj, 1, 0);
   spinbutton_instruments_volume_swing_adj = new Gtk::Adjustment(0, 0, 100, 1, 10, 10);
   spinbutton_instruments_volume_swing = new Gtk::SpinButton(*spinbutton_instruments_volume_swing_adj, 1, 0);

   spinbutton_instruments_default_cutoff_adj=new Gtk::Adjustment(0, 0, 127, 1, 10, 10);;
   spinbutton_instruments_default_cutoff=new Gtk::SpinButton(*spinbutton_instruments_default_cutoff_adj, 1, 0);
   spinbutton_instruments_default_Q_adj=new Gtk::Adjustment(0, 0, 127, 1, 10, 10);
   spinbutton_instruments_default_Q=new Gtk::SpinButton(*spinbutton_instruments_default_Q_adj, 1, 0);


   spinbutton_instruments_default_cutoff->show();

   spinbutton_instruments_default_Q->show();


   spinbutton_instruments_pan_envelope_loop_begin_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_instruments_pan_envelope_loop_begin = new Gtk::SpinButton(*spinbutton_instruments_pan_envelope_loop_begin_adj, 1, 0);
   spinbutton_instruments_pan_envelope_loop_end_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_instruments_pan_envelope_loop_end = new Gtk::SpinButton(*spinbutton_instruments_pan_envelope_loop_end_adj, 1, 0);
   spinbutton_instruments_pan_envelope_susloop_begin_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_instruments_pan_envelope_susloop_begin = new Gtk::SpinButton(*spinbutton_instruments_pan_envelope_susloop_begin_adj, 1, 0);
   spinbutton_instruments_pan_envelope_susloop_end_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_instruments_pan_envelope_susloop_end = new Gtk::SpinButton(*spinbutton_instruments_pan_envelope_susloop_end_adj, 1, 0);
   spinbutton_instruments_pan_default_value_adj = new Gtk::Adjustment(0, 0, 64, 1, 10, 10);
   spinbutton_instruments_pan_default_value = new Gtk::SpinButton(*spinbutton_instruments_pan_default_value_adj, 1, 0);
   spinbutton_instruments_pan_swing_adj = new Gtk::Adjustment(0, 0, 64, 1, 10, 10);
   spinbutton_instruments_pan_swing = new Gtk::SpinButton(*spinbutton_instruments_pan_swing_adj, 1, 0);
   spinbutton_instruments_pitch_pan_separation_adj = new Gtk::Adjustment(0, -32, 32, 1, 10, 10);
   spinbutton_instruments_pitch_pan_separation = new Gtk::SpinButton(*spinbutton_instruments_pitch_pan_separation_adj, 1, 0);
   spinbutton_instruments_pan_pitch_center_adj = new Gtk::Adjustment(0, 0, 119, 1, 10, 10);
   spinbutton_instruments_pan_pitch_center = new Gtk::SpinButton(*spinbutton_instruments_pan_pitch_center_adj, 1, 0);
   spinbutton_instruments_frequency_envelope_loop_begin_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_instruments_frequency_envelope_loop_begin = new Gtk::SpinButton(*spinbutton_instruments_frequency_envelope_loop_begin_adj, 1, 0);
   spinbutton_instruments_frequency_envelope_loop_end_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_instruments_frequency_envelope_loop_end = new Gtk::SpinButton(*spinbutton_instruments_frequency_envelope_loop_end_adj, 1, 0);
   spinbutton_instruments_frequency_envelope_susloop_begin_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_instruments_frequency_envelope_susloop_begin = new Gtk::SpinButton(*spinbutton_instruments_frequency_envelope_susloop_begin_adj, 1, 0);
   spinbutton_instruments_frequency_envelope_susloop_end_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton_instruments_frequency_envelope_susloop_end = new Gtk::SpinButton(*spinbutton_instruments_frequency_envelope_susloop_end_adj, 1, 0);


   spinbutton49_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton49 = new Gtk::SpinButton(*spinbutton49_adj, 1, 0);
   spinbutton50_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton50 = new Gtk::SpinButton(*spinbutton50_adj, 1, 0);
   spinbutton51_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton51 = new Gtk::SpinButton(*spinbutton51_adj, 1, 0);
   spinbutton52_adj = new Gtk::Adjustment(1, 0, 100, 1, 10, 10);
   spinbutton52 = new Gtk::SpinButton(*spinbutton52_adj, 1, 0);
   spinbutton_variables_tempo_adj = new Gtk::Adjustment(0, 31, 255, 1, 10, 10);
   spinbutton_variables_tempo = new Gtk::SpinButton(*spinbutton_variables_tempo_adj, 1, 0);
   spinbutton_variables_speed_adj = new Gtk::Adjustment(0, 1, 255, 1, 10, 10);
   spinbutton_variables_speed = new Gtk::SpinButton(*spinbutton_variables_speed_adj, 1, 0);
   spinbutton_variables_glb_volume_adj = new Gtk::Adjustment(0, 0, 128, 1, 10, 10);
   spinbutton_variables_glb_volume = new Gtk::SpinButton(*spinbutton_variables_glb_volume_adj, 1, 0);
   spinbutton_variables_mix_volume_adj = new Gtk::Adjustment(0, 0, 128, 1, 10, 10);
   spinbutton_variables_mix_volume = new Gtk::SpinButton(*spinbutton_variables_mix_volume_adj, 1, 0);
   spinbutton_variables_stereo_separation_adj = new Gtk::Adjustment(0, 0, 128, 1, 10, 10);
   spinbutton_variables_stereo_separation = new Gtk::SpinButton(*spinbutton_variables_stereo_separation_adj, 1, 0);
   radiobutton_variables_control_instruments = new Gtk::RadioButton( "Instruments");

   radiobutton_variables_control_samples = new Gtk::RadioButton( "Samples");
   radiobutton_variables_control_samples->set_group(radiobutton_variables_control_instruments->group());

   radiobutton_variables_playback_stereo = new Gtk::RadioButton( "Stereo");


   radiobutton_variables_playback_mono = new Gtk::RadioButton( "Mono");
   radiobutton_variables_playback_mono->set_group(radiobutton_variables_playback_stereo->group());	

   radiobutton_variables_slides_linear = new Gtk::RadioButton( "Linear");


   radiobutton_variables_slides_amiga = new Gtk::RadioButton( "Amiga");
   radiobutton_variables_slides_amiga->set_group(radiobutton_variables_slides_linear->group());


   label10.set_name("label10");
   label10.set_alignment(0.5, 0.5);
   label10.set_padding(0, 0);
   label11.set_name("label11");
   label11.set_alignment(0.5, 0.5);
   label11.set_padding(0, 0);
   label13.set_name("label13");
   label13.set_alignment(0.5, 0.5);
   label13.set_padding(0, 0);
   label14.set_name("label14");
   label14.set_alignment(0.5, 0.5);
   label14.set_padding(0, 0);
   label12.set_name("label12");
   label12.set_alignment(0.5, 0.5);
   label12.set_padding(0, 0);
   entry_main_song_name.set_usize(-1, 17);
   entry_main_song_name.set_name("entry_main_song_name");
   entry_main_song_name.set_editable(true);
   entry_main_song_name.changed.connect(slot(this, &Interface::on_entry_main_song_name_changed));
   entry_main_file_name.set_usize(-1, 17);
   entry_main_file_name.set_name("entry_main_file_name");
   entry_main_file_name.set_editable(false);
   entry_main_row.set_usize(70, 17);
   entry_main_row.set_name("entry_main_row");
   entry_main_row.set_editable(false);
   hseparator1.set_name("hseparator1");
   hbox3.set_name("hbox3");
   hbox3.pack_start(entry_main_row, false, false, 0);
   hbox3.pack_start(hseparator1);
   entry_main_pattern.set_usize(70, 17);
   entry_main_pattern.set_name("entry_main_pattern");
   entry_main_pattern.set_editable(false);
   hseparator2.set_name("hseparator2");
   hbox4.set_name("hbox4");
   hbox4.pack_start(entry_main_pattern, false, false, 0);
   hbox4.pack_start(hseparator2);
   entry_main_order.set_usize(70, 17);
   entry_main_order.set_name("entry_main_order");
   entry_main_order.set_editable(false);
   hseparator3.set_name("hseparator3");
   hbox5.set_name("hbox5");
   hbox5.pack_start(entry_main_order, false, false, 0);
   hbox5.pack_start(hseparator3);
   table1.set_name("table1");
   table1.attach(label10, 0, 1, 0, 1, 0, 0, 0, 0);
   table1.attach(label11, 0, 1, 1, 2, 0, 0, 0, 0);
   table1.attach(label13, 0, 1, 3, 4, 0, 0, 0, 0);
   table1.attach(label14, 0, 1, 4, 5, 0, 0, 0, 0);
   table1.attach(label12, 0, 1, 2, 3, GTK_FILL, 0, 0, 0);
   table1.attach(entry_main_song_name, 1, 2, 0, 1, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   table1.attach(entry_main_file_name, 1, 2, 1, 2, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   table1.attach(hbox3, 1, 2, 4, 5, GTK_FILL, GTK_FILL, 0, 0);
   table1.attach(hbox4, 1, 2, 3, 4, GTK_FILL, GTK_FILL, 0, 0);
   table1.attach(hbox5, 1, 2, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
   vseparator1.set_usize(10, -1);
   vseparator1.set_name("vseparator1");
   label15.set_name("label15");
   label15.set_alignment(0.5, 0.5);
   label15.set_padding(0, 0);
   label16.set_name("label16");
   label16.set_alignment(0.5, 0.5);
   label16.set_padding(0, 0);
   label17.set_name("label17");
   label17.set_alignment(0.5, 0.5);
   label17.set_padding(0, 0);
   entry_main_instrument.set_usize(-1, 17);
   entry_main_instrument.set_name("entry_main_instrument");
   entry_main_instrument.set_editable(false);
   entry_main_octave.set_usize(29, 17);
   entry_main_octave.set_name("entry_main_octave");
   entry_main_octave.set_editable(false);
   hseparator41.set_name("hseparator41");
   hbox56.set_name("hbox56");
   hbox56.pack_start(entry_main_octave, false, false, 0);
   hbox56.pack_start(hseparator41);
   entry_main_speed_tempo.set_usize(87, 17);
   entry_main_speed_tempo.set_name("entry_main_speed_tempo");
   entry_main_speed_tempo.set_editable(false);
   hseparator42.set_name("hseparator42");
   hbox57.set_name("hbox57");
   hbox57.pack_start(entry_main_speed_tempo, false, false, 0);
   hbox57.pack_start(hseparator42);
   table2.set_name("table2");
   table2.attach(label15, 0, 1, 0, 1, 0, 0, 0, 0);
   table2.attach(label16, 0, 1, 1, 2, 0, 0, 0, 0);
   table2.attach(label17, 0, 1, 2, 3, 0, 0, 0, 0);
   table2.attach(entry_main_instrument, 1, 2, 0, 1, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   table2.attach(hbox56, 1, 2, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
   table2.attach(hbox57, 1, 2, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
   hseparator18.set_name("hseparator18");
   button_main_play_prev_pattern.set_name("button_main_play_prev_pattern");
   connect_to_method(button_main_play_prev_pattern.clicked, (Interface*)this, &Interface::on_button_main_play_prev_pattern_clicked);
   button_main_stop.set_name("button_main_stop");
   connect_to_method(button_main_stop.clicked, (Interface*)this, &Interface::on_button_main_stop_clicked);
   button_main_play.set_name("button_main_play");
   connect_to_method(button_main_play.clicked, (Interface*)this, &Interface::on_button_main_play_clicked);
   button_main_play_next_pattern.set_name("button_main_play_next_pattern");
   connect_to_method(button_main_play_next_pattern.clicked, (Interface*)this, &Interface::on_button_main_play_next_pattern_clicked);
   vseparator2.set_name("vseparator2");
   button_main_play_pattern.set_name("button_main_play_pattern");
   connect_to_method(button_main_play_pattern.clicked, (Interface*)this, &Interface::on_button_main_play_pattern_clicked);
   button_main_play_custom.set_name("button_main_play_custom");
   connect_to_method(button_main_play_custom.clicked, (Interface*)this, &Interface::on_button_main_play_custom_clicked);
   vseparator3.set_name("vseparator3");
   button_main_help.set_name("button_main_help");
   connect_to_method(button_main_help.clicked, (Interface*)this, &Interface::on_button_main_help_clicked);
   hbox2.set_name("hbox2");
   hbox2.pack_start(button_main_play_prev_pattern, false, false, 0);
   hbox2.pack_start(button_main_stop, false, false, 0);
   hbox2.pack_start(button_main_play, false, false, 0);
   hbox2.pack_start(button_main_play_next_pattern, false, false, 0);
   hbox2.pack_start(vseparator2, false, false, 4);
   hbox2.pack_start(button_main_play_pattern, false, false, 0);
   hbox2.pack_start(button_main_play_custom, false, false, 0);
   hbox2.pack_start(vseparator3);
   hbox2.pack_start(button_main_file,false,false,0);
   hbox2.pack_start(button_main_help, false, false, 0);

   vbox2.set_name("vbox2");
   vbox2.pack_start(table2);
   vbox2.pack_start(hseparator18);
   vbox2.pack_start(hbox2, false, true, 0);
   hbox1.set_name("hbox1");
   hbox1.set_border_width(6);
   hbox1.pack_start(table1);
   hbox1.pack_start(vseparator1, false, true, 0);
   hbox1.pack_start(vbox2);
   entry_main_upper.set_name("entry_main_upper");
   entry_main_upper.set_editable(false);
   tracker.set_name("tracker");
   tracker_viewport.add(tracker);
   tracker_viewport.show();
   label1.set_name("label1");
   label1.set_alignment(0.5, 0.5);
   label1.set_padding(0, 0);
   clist_samples_list.set_name("clist_samples_list");
   clist_samples_list.set_column_title(0, "#");
   clist_samples_list.set_column_justification(0, GTK_JUSTIFY_CENTER);
   clist_samples_list.set_column_width(0, 20);
   clist_samples_list.set_column_title(1, "S");
   clist_samples_list.set_column_justification(1, GTK_JUSTIFY_CENTER);
   clist_samples_list.set_column_width(1, 9);
   clist_samples_list.set_column_title(2, "Name");
   clist_samples_list.set_column_justification(2, GTK_JUSTIFY_CENTER);
   clist_samples_list.set_column_width(2, 80);
   clist_samples_list.column_titles_show();
   scrolledwindow3.set_name("scrolledwindow3");
   scrolledwindow3.set_policy(GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
   scrolledwindow3.add(clist_samples_list);
   hseparator17.set_name("hseparator17");
   entry_samples_samplename.set_name("entry_samples_samplename");
   entry_samples_samplename.set_editable(true);
   vbox5.set_name("vbox5");
   vbox5.pack_start(scrolledwindow3);
   vbox5.pack_start(hseparator17, false, false, 4);
   vbox5.pack_start(hbox_sample_options, false, false, 0);
   hbox_sample_options.pack_start(entry_samples_samplename, true, true, 0);
   hbox_sample_options.pack_start(button_samples_edit, false, false, 0);


   frame1.set_name("frame1");
   frame1.set_border_width(3);
   frame1.set_label_align(0, 0);
   frame1.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame1.add(vbox5);
   vseparator4.set_name("vseparator4");
   label34.set_name("label34");
   label34.set_alignment(0.5, 0.5);
   label34.set_padding(0, 0);
   hseparator14.set_name("hseparator14");
   hbox13.set_name("hbox13");
   hbox13.pack_start(label34, false, false, 0);
   hbox13.pack_start(hseparator14);
   label20.set_name("label20");
   label20.set_alignment(0.5, 0.5);
   label20.set_padding(0, 0);
   hseparator4.set_name("hseparator4");
   spinbutton_samples_def_volume->set_name("spinbutton_samples_def_volume");
//   spinbutton_samples_def_volume->set_editable(true);
   hbox7.set_name("hbox7");
   hbox7.pack_start(label20, false, false, 0);
//   hbox7.pack_start(hseparator4);
//   hbox7.pack_start(*spinbutton_samples_def_volume, false, false, 0);
   hbox7.pack_start(*spinbutton_samples_def_volume, true, true, 0);

   frame2.set_name("frame2");
   frame2.set_label_align(0, 0);
   frame2.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame2.add(hbox7);
   label21.set_name("label21");
   label21.set_alignment(0.5, 0.5);
   label21.set_padding(0, 0);
   hseparator5.set_name("hseparator5");
   spinbutton_samples_glb_volume->set_name("spinbutton_samples_glb_volume");

   hbox8.set_name("hbox8");
   hbox8.pack_start(label21, false, false, 0);
//   hbox8.pack_start(hseparator5);
   hbox8.pack_start(*spinbutton_samples_glb_volume, true, true, 0);
   frame3.set_name("frame3");
   frame3.set_label_align(0, 0);
   frame3.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame3.add(hbox8);
   checkbutton_samples_def_pan.set_name("checkbutton_samples_def_pan");
   connect_to_method(checkbutton_samples_def_pan.clicked, (Interface*)this, &Interface::on_checkbutton_samples_def_pan_clicked);
   hseparator6.set_name("hseparator6");
   spinbutton_samples_def_pan->set_name("spinbutton_samples_def_pan");

   hbox9.set_name("hbox9");
   hbox9.pack_start(checkbutton_samples_def_pan, false, false, 0);
//   hbox9.pack_start(hseparator6);
   hbox9.pack_start(*spinbutton_samples_def_pan, true, true, 0);
   frame4.set_name("frame4");
   frame4.set_label_align(0, 0);
   frame4.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame4.add(hbox9);
   label35.set_name("label35");
   label35.set_alignment(0.5, 0.5);
   label35.set_padding(0, 0);
   hseparator15.set_name("hseparator15");
   hbox14.set_name("hbox14");
   hbox14.pack_start(label35, false, false, 0);
   hbox14.pack_start(hseparator15);
   label22.set_name("label22");
   label22.set_alignment(0.5, 0.5);
   label22.set_padding(0, 0);
   hseparator7.set_name("hseparator7");
   spinbutton_samples_vibrato_speed->set_name("spinbutton_samples_vibrato_speed");

   hbox10.set_name("hbox10");
   hbox10.pack_start(label22, false, false, 0);
//   hbox10.pack_start(hseparator7);
   hbox10.pack_start(*spinbutton_samples_vibrato_speed, true, true, 0);
   frame5.set_name("frame5");
   frame5.set_label_align(0, 0);
   frame5.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame5.add(hbox10);
   label23.set_name("label23");
   label23.set_alignment(0.5, 0.5);
   label23.set_padding(0, 0);
   hseparator8.set_name("hseparator8");
   spinbutton_samples_vibrato_depth->set_name("spinbutton_samples_vibrato_depth");

   hbox11.set_name("hbox11");
   hbox11.pack_start(label23, false, false, 0);
//   hbox11.pack_start(hseparator8);
   hbox11.pack_start(*spinbutton_samples_vibrato_depth, true, true, 0);
   frame6.set_name("frame6");
   frame6.set_label_align(0, 0);
   frame6.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame6.add(hbox11);
   label36.set_name("label36");
   label36.set_alignment(0.5, 0.5);
   label36.set_padding(0, 0);
   hseparator16.set_name("hseparator16");
   spinbutton_samples_vibrato_rate->set_name("spinbutton_samples_vibrato_rate");

   hbox16.set_name("hbox16");
   hbox16.pack_start(label36, false, false, 0);
//   hbox16.pack_start(hseparator16);
   hbox16.pack_start(*spinbutton_samples_vibrato_rate, true, true, 0);
   frame7.set_name("frame7");
   frame7.set_label_align(0, 0);
   frame7.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame7.add(hbox16);
   radiobutton_samples_waveform_saw->set_name("radiobutton_samples_waveform_saw");
   connect_to_method(radiobutton_samples_waveform_saw->clicked, (Interface*)this, &Interface::on_radiobutton_samples_waveform_saw_clicked);
   radiobutton_samples_waveform_sine->set_name("radiobutton_samples_waveform_sine");
   connect_to_method(radiobutton_samples_waveform_sine->clicked, (Interface*)this, &Interface::on_radiobutton_samples_waveform_sine_clicked);
   radiobutton_samples_waveform_square->set_name("radiobutton_samples_waveform_square");
   connect_to_method(radiobutton_samples_waveform_square->clicked, (Interface*)this, &Interface::on_radiobutton_samples_waveform_square_clicked);
   radiobutton_samples_waveform_random->set_name("radiobutton_samples_waveform_random");
   connect_to_method(radiobutton_samples_waveform_random->clicked, (Interface*)this, &Interface::on_radiobutton_samples_waveform_random_clicked);
   table4.set_name("table4");
   table4.attach(*radiobutton_samples_waveform_saw, 1, 2, 0, 1, GTK_FILL, 0, 0, 0);
   table4.attach(*radiobutton_samples_waveform_sine, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
   table4.attach(*radiobutton_samples_waveform_square, 0, 1, 1, 2, 0, 0, 0, 0);
   table4.attach(*radiobutton_samples_waveform_random, 1, 2, 1, 2, 0, 0, 0, 0);
   frame8.set_name("frame8");
   frame8.set_label_align(0, 0);
   frame8.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame8.add(table4);
   vbox3.set_name("vbox3");
   vbox3.pack_start(hbox13);
   vbox3.pack_start(frame2);
   vbox3.pack_start(frame3);
   vbox3.pack_start(frame4);
   vbox3.pack_start(hbox14);
   vbox3.pack_start(frame5);
   vbox3.pack_start(frame6);
   vbox3.pack_start(frame7);
   vbox3.pack_start(frame8);
   vseparator10.set_name("vseparator10");
   label24.set_name("label24");
   label24.set_alignment(0.5, 0.5);
   label24.set_padding(0, 0);
   entry_samples_filename.set_usize(-1, 19);
   entry_samples_filename.set_name("entry_samples_filename");
   entry_samples_filename.set_editable(true);
   label25.set_name("label25");
   label25.set_alignment(0.5, 0.5);
   label25.set_padding(0, 0);
   spinbutton_samples_speed->set_usize(-1, 19);
   spinbutton_samples_speed->set_name("spinbutton_samples_speed");
   spinbutton_samples_speed->set_editable(true);
   label27.set_name("label27");
   label27.set_alignment(0.5, 0.5);
   label27.set_padding(0, 0);
   label28.set_name("label28");
   label28.set_alignment(0.5, 0.5);
   label28.set_padding(0, 0);
   spinbutton_samples_loop_begin->set_usize(-1, 17);
   spinbutton_samples_loop_begin->set_name("spinbutton_samples_loop_begin");
   spinbutton_samples_loop_begin->set_editable(true);
   spinbutton_samples_loop_end->set_usize(-1, 17);
   spinbutton_samples_loop_end->set_name("spinbutton_samples_loop_end");
   spinbutton_samples_loop_end->set_editable(true);
   label30.set_name("label30");
   label30.set_alignment(0.5, 0.5);
   label30.set_padding(0, 0);
   label31.set_name("label31");
   label31.set_alignment(0.5, 0.5);
   label31.set_padding(0, 0);
   spinbutton_samples_susloop_begin->set_usize(-1, 17);
   spinbutton_samples_susloop_begin->set_name("spinbutton_samples_susloop_begin");
   spinbutton_samples_susloop_begin->set_editable(true);
   spinbutton_samples_susloop_end->set_usize(-1, 17);
   spinbutton_samples_susloop_end->set_name("spinbutton_samples_susloop_end");
   spinbutton_samples_susloop_end->set_editable(true);
   hseparator10.set_name("hseparator10");
   hseparator9.set_name("hseparator9");
   label32.set_name("label32");
   label32.set_alignment(0.5, 0.5);
   label32.set_padding(0, 0);
   label33.set_name("label33");
   label33.set_alignment(0.5, 0.5);
   label33.set_padding(0, 0);
   entry_samples_quality.set_usize(-1, 17);
   entry_samples_quality.set_name("entry_samples_quality");
   entry_samples_quality.set_editable(false);
   entry_samples_length.set_usize(-1, 17);
   entry_samples_length.set_name("entry_samples_length");
   entry_samples_length.set_editable(false);
   erwer.set_name("erwer");
   hseparator11.set_name("hseparator11");
   label38.set_name("label38");
   label38.set_alignment(0.5, 0.5);
   label38.set_padding(0, 0);
   combo_samples_loop_type.set_name("combo_samples_loop_type");
   {

      const char *items[] = { "|None|","|Forward->","<-Ping Pong->", 0 };
      combo_samples_loop_type.set_popdown_strings(items);

   }
   combo_samples_loop_type.get_entry()->set_name("combo-entry1");
   combo_samples_loop_type.get_entry()->set_editable(false);
   combo_samples_loop_type.get_entry()->set_text("None");
   label39.set_name("label39");
   label39.set_alignment(0.5, 0.5);
   label39.set_padding(0, 0);
   combo_samples_susloop_type.set_name("combo_samples_susloop_type");
   {

      const char *items[] = { "None","Forward","Ping Pong", 0 };
      combo_samples_susloop_type.set_popdown_strings(items);

   }
   combo_samples_susloop_type.get_entry()->set_name("comboentrer");
   combo_samples_susloop_type.get_entry()->set_editable(false);
   combo_samples_susloop_type.get_entry()->set_text("None");
   table3.set_name("table3");
   table3.attach(label24, 0, 1, 0, 1, 0, 0, 0, 0);
   table3.attach(entry_samples_filename, 1, 2, 0, 1, GTK_FILL, 0, 0, 0);
   table3.attach(label25, 0, 1, 1, 2, 0, 0, 0, 0);

   table3.attach(*spinbutton_samples_base_note, 1, 2, 1, 2, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   table3.attach(entry_samples_base_note, 1, 2, 2, 3, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   table3.attach(*spinbutton_samples_finetune, 0, 1, 2, 3, GTK_EXPAND|GTK_FILL, 0, 0, 0);

   table3.attach(label27, 0, 1, 4, 5, 0, 0, 0, 0);
   table3.attach(label28, 0, 1, 5, 6, 0, 0, 0, 0);
   table3.attach(*spinbutton_samples_loop_begin, 1, 2, 4, 5, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   table3.attach(*spinbutton_samples_loop_end, 1, 2, 5, 6, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   table3.attach(label30, 0, 1, 7, 8, 0, 0, 0, 0);
   table3.attach(label31, 0, 1, 8, 9, 0, 0, 0, 0);
   table3.attach(*spinbutton_samples_susloop_begin, 1, 2, 7, 8, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   table3.attach(*spinbutton_samples_susloop_end, 1, 2, 8, 9, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   table3.attach(hseparator10, 1, 2, 9, 10, GTK_FILL, GTK_FILL, 0, 0);
   table3.attach(hseparator9, 0, 1, 9, 10, GTK_FILL, GTK_EXPAND|GTK_FILL, 0, 5);
   table3.attach(label32, 0, 1, 10, 11, 0, 0, 0, 0);
   table3.attach(label33, 0, 1, 11, 12, 0, 0, 0, 0);
   table3.attach(entry_samples_quality, 1, 2, 10, 11, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   table3.attach(entry_samples_length, 1, 2, 11, 12, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   table3.attach(erwer, 1, 2, 12, 13, GTK_FILL, GTK_FILL, 0, 0);
   table3.attach(hseparator11, 0, 1, 12, 13, GTK_FILL, GTK_EXPAND|GTK_FILL, 0, 4);
   table3.attach(label38, 0, 1, 3, 4, 0, 0, 0, 0);
   table3.attach(combo_samples_loop_type, 1, 2, 3, 4, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   table3.attach(label39, 0, 1, 6, 7, 0, 0, 0, 0);
   table3.attach(combo_samples_susloop_type, 1, 2, 6, 7, GTK_EXPAND|GTK_FILL, 0, 0, 0);
   sample_view_samples_current.set_name("sample_view_samples_current");
//   sample_view_samples_current.set_alignment(0.5, 0.5);
 //  sample_view_samples_current.set_padding(0, 0);
   button_samples_edit.set_name("button_samples_edit");
   connect_to_method(button_samples_edit.clicked, (Interface*)this, &Interface::on_button_samples_edit_clicked);
   button_samples_play.set_name("button_samples_play");
   connect_to_method(button_samples_play.clicked, (Interface*)this, &Interface::on_button_samples_play_clicked);
   hbox12.set_name("hbox12");
   hbox12.pack_end(button_samples_play, false, false, 0);
   vbox4.set_name("vbox4");
   vbox4.pack_start(table3, false, false, 0);
   samples_viewport.add(sample_view_samples_current);

   vbox4.pack_start(samples_viewport);
   samples_viewport.show();
   vbox4.pack_start(hbox12, false, false, 0);
   hbox55.set_name("hbox55");
   hbox55.pack_start(vbox3);
   hbox55.pack_start(vseparator10, true, true, 7);
   hbox55.pack_start(vbox4);
   viewport6.set_name("viewport6");
   viewport6.add(hbox55);
   scrolledInterface2.set_name("scrolledInterface2");
   scrolledInterface2.set_policy(GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
   scrolledInterface2.add(viewport6);
   hbox6.set_name("hbox6");
   hbox6.pack_start(frame1);
   hbox6.pack_start(vseparator4, false, false, 4);
   hbox6.pack_start(scrolledInterface2);
   label2.set_name("label2");
   label2.set_alignment(0.5, 0.5);
   label2.set_padding(0, 0);
   clist_instrments_names.set_name("clist_instrments_names");
   clist_instrments_names.set_column_title(0, "#");
   clist_instrments_names.set_column_justification(0, GTK_JUSTIFY_CENTER);
   clist_instrments_names.set_column_width(0, 19);
   clist_instrments_names.set_column_title(1, "Name");
   clist_instrments_names.set_column_justification(1, GTK_JUSTIFY_LEFT);
   clist_instrments_names.set_column_width(1, 80);
   clist_instrments_names.column_titles_show();

   scrolledwindow2.set_name("scrolledwindow2");
   scrolledwindow2.set_policy(GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
   scrolledwindow2.add(clist_instrments_names);
   hseparator19.set_name("hseparator19");
   entry_instrument_name.set_name("entry_instrument_name");
   entry_instrument_name.set_editable(true);
   connect_to_method(entry_instrument_name.changed, (Interface*)this, &Interface::on_entry_instrument_name_changed);
   vbox6.set_name("vbox6");
   vbox6.pack_start(scrolledwindow2);
   vbox6.pack_start(hseparator19, false, false, 3);
   vbox6.pack_start(hbox_instrument_options, false, false, 0);
   hbox_instrument_options.pack_start(entry_instrument_name, true, true, 0);
   hbox_instrument_options.pack_start(button_instrument_options, false, false, 0);
   hbox_instrument_options.show();
   button_instrument_options.clicked.connect(slot(this,&Interface::on_button_instrument_options_clicked));

   button_instrument_options.show();
   frame9.set_name("frame9");
   frame9.set_border_width(3);
   frame9.set_label_align(0, 0);
   frame9.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame9.add(vbox6);
   equivtable_instruments.set_name("equivtable_instruments");
   frame10.set_name("frame10");
   frame10.set_label_align(0, 0);
   frame10.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame10.add(equivtable_instruments);
   vseparator6.set_name("vseparator6");
   hseparator20.set_name("hseparator20");
   label50.set_name("label50");
   label50.set_alignment(0.5, 0.5);
   label50.set_padding(0, 0);
   radiobutton_instruments_nna_note_cut->set_name("radiobutton_instruments_nna_note_cut");
   connect_to_method(radiobutton_instruments_nna_note_cut->clicked, (Interface*)this, &Interface::on_radiobutton_instruments_nna_note_cut_clicked);
   radiobutton_instruments_nna_note_continue->set_name("radiobutton_instruments_nna_note_continue");
   connect_to_method(radiobutton_instruments_nna_note_continue->clicked, (Interface*)this, &Interface::on_radiobutton_instruments_nna_note_continue_clicked);
   radiobutton_instruments_nna_note_off->set_name("radiobutton_instruments_nna_note_off");
   connect_to_method(radiobutton_instruments_nna_note_off->clicked, (Interface*)this, &Interface::on_radiobutton_instruments_nna_note_off_clicked);
   radiobutton_instruments_nna_note_fade->set_name("radiobutton_instruments_nna_note_fade");
   connect_to_method(radiobutton_instruments_nna_note_fade->clicked, (Interface*)this, &Interface::on_radiobutton_instruments_nna_note_fade_clicked);
   hseparator21.set_name("hseparator21");
   label51.set_name("label51");
   label51.set_alignment(0.5, 0.5);
   label51.set_padding(0, 0);
   radiobutton_instruments_dca_disabled->set_name("radiobutton_instruments_dca_disabled");
   connect_to_method(radiobutton_instruments_dca_disabled->clicked, (Interface*)this, &Interface::on_radiobutton_instruments_dca_disabled_clicked);
   radiobutton_instruments_dca_note->set_name("radiobutton_instruments_dca_note");
   connect_to_method(radiobutton_instruments_dca_note->clicked, (Interface*)this, &Interface::on_radiobutton_instruments_dca_note_clicked);
   radiobutton_instruments_dca_sample->set_name("radiobutton_instruments_dca_sample");
   connect_to_method(radiobutton_instruments_dca_sample->clicked, (Interface*)this, &Interface::on_radiobutton_instruments_dca_sample_clicked);
   radiobutton_instruments_dca_disabled_instrument->set_name("radiobutton_instruments_dca_disabled_instrument");
   connect_to_method(radiobutton_instruments_dca_disabled_instrument->clicked, (Interface*)this, &Interface::on_radiobutton_instruments_dca_disabled_instrument_clicked);
   radiobutton_instruments_dca_note_fade->set_name("radiobutton_instruments_dca_note_fade");
   connect_to_method(radiobutton_instruments_dca_note_fade->clicked, (Interface*)this, &Interface::on_radiobutton_instruments_dca_note_fade_clicked);
   radiobutton_instruments_dca_note_off->set_name("radiobutton_instruments_dca_note_off");
   connect_to_method(radiobutton_instruments_dca_note_off->clicked, (Interface*)this, &Interface::on_radiobutton_instruments_dca_note_off_clicked);
   radiobutton_instruments_dca_note_cut->set_name("radiobutton_instruments_dca_note_cut");
   connect_to_method(radiobutton_instruments_dca_note_cut->clicked, (Interface*)this, &Interface::on_radiobutton_instruments_dca_note_cut_clicked);
   hseparator23.set_name("hseparator23");
   table5.set_name("table5");
   table5.attach(*radiobutton_instruments_dca_disabled, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
   table5.attach(*radiobutton_instruments_dca_note, 0, 1, 1, 2, GTK_FILL, 0, 0, 0);
   table5.attach(*radiobutton_instruments_dca_sample, 0, 1, 2, 3, GTK_FILL, 0, 0, 0);
   table5.attach(*radiobutton_instruments_dca_disabled_instrument, 0, 1, 3, 4, GTK_FILL, 0, 0, 0);
   table5.attach(*radiobutton_instruments_dca_note_fade, 1, 2, 2, 3, GTK_FILL, 0, 0, 0);
   table5.attach(*radiobutton_instruments_dca_note_off, 1, 2, 1, 2, GTK_FILL, 0, 0, 0);
   table5.attach(*radiobutton_instruments_dca_note_cut, 1, 2, 0, 1, GTK_FILL, 0, 0, 0);
   table5.attach(hseparator23, 1, 2, 3, 4, GTK_FILL, GTK_FILL, 0, 0);
   hseparator22.set_name("hseparator22");
   label52.set_name("label52");
   label52.set_alignment(0.5, 0.5);
   label52.set_padding(0, 0);
   entry_instruments_name.set_name("entry_instruments_name");
   entry_instruments_name.set_editable(true);
   connect_to_method(entry_instruments_name.changed, (Interface*)this, &Interface::on_entry_instruments_name_changed);
   hbox19.set_name("hbox19");
   hbox19.pack_start(label52, false, false, 0);
   hbox19.pack_start(entry_instruments_name);
   vbox7.set_name("vbox7");
   vbox7.pack_start(hseparator20);
   vbox7.pack_start(label50, false, false, 0);
   vbox7.pack_start(*radiobutton_instruments_nna_note_cut, false, false, 0);
   vbox7.pack_start(*radiobutton_instruments_nna_note_continue, false, false, 0);
   vbox7.pack_start(*radiobutton_instruments_nna_note_off, false, false, 0);
   vbox7.pack_start(*radiobutton_instruments_nna_note_fade, false, false, 0);
   vbox7.pack_start(hseparator21);
   vbox7.pack_start(label51, false, false, 0);
   vbox7.pack_start(table5);
   vbox7.pack_start(hseparator22);
   vbox7.pack_start(hbox19);
   hbox18.set_name("hbox18");
   hbox18.pack_start(frame10, false, false, 0);
   hbox18.pack_start(vseparator6, false, false, 4);
   hbox18.pack_start(vbox7);
   label46.set_name("label46");
   label46.set_alignment(0.5, 0.5);
   label46.set_padding(0, 0);
   envelope_instruments_volume.set_usize(-1, 100);
   frame19.set_name("frame19");
   frame19.set_label_align(0, 0);
   frame19.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame19.add(envelope_instruments_volume);
   checkbutton_instruments_volume_envelope.set_usize(-1, 17);
   checkbutton_instruments_volume_envelope.set_name("checkbutton_instruments_volume_envelope");
   connect_to_method(checkbutton_instruments_volume_envelope.clicked, (Interface*)this, &Interface::on_checkbutton_instruments_volume_envelope_clicked);
   checkbutton_instruments_volume_envelope_carry.set_usize(-1, 17);
   checkbutton_instruments_volume_envelope_carry.set_name("checkbutton_instruments_volume_envelope_carry");
   connect_to_method(checkbutton_instruments_volume_envelope_carry.clicked, (Interface*)this, &Interface::on_checkbutton_instruments_volume_envelope_carry_clicked);
   hseparator29.set_name("hseparator29");
   checkbutton_instruments_volume_envelope_loop.set_usize(-1, 17);
   checkbutton_instruments_volume_envelope_loop.set_name("checkbutton_instruments_volume_envelope_loop");
   connect_to_method(checkbutton_instruments_volume_envelope_loop.clicked, (Interface*)this, &Interface::on_checkbutton_instruments_volume_envelope_loop_clicked);
   spinbutton_instruments_volume_envelope_loop_begin->set_usize(-1, 17);
   spinbutton_instruments_volume_envelope_loop_begin->set_name("spinbutton_instruments_volume_envelope_loop_begin");
   spinbutton_instruments_volume_envelope_loop_begin->set_editable(true);
   label23423.set_name("label23423");
   label23423.set_alignment(0.5, 0.5);
   label23423.set_padding(0, 0);
   hbox31.set_name("hbox31");
   hbox31.pack_end(*spinbutton_instruments_volume_envelope_loop_begin, false, false, 0);
   hbox31.pack_start(label23423, false, false, 0);
   label234234.set_name("label234234");
   label234234.set_alignment(0.5, 0.5);
   label234234.set_padding(0, 0);
   spinbutton_instruments_volume_envelope_loop_end->set_usize(-1, 17);
   spinbutton_instruments_volume_envelope_loop_end->set_name("spinbutton_instruments_volume_envelope_loop_end");
   spinbutton_instruments_volume_envelope_loop_end->set_editable(true);
   hbox32.set_name("hbox32");
   hbox32.pack_start(label234234, false, false, 0);
   hbox32.pack_end(*spinbutton_instruments_volume_envelope_loop_end, false, false, 0);
   hseparator30.set_name("hseparator30");
   checkbutton_instruments_volume_envelope_susloop.set_usize(-1, 17);
   checkbutton_instruments_volume_envelope_susloop.set_name("checkbutton_instruments_volume_envelope_susloop");
   connect_to_method(checkbutton_instruments_volume_envelope_susloop.clicked, (Interface*)this, &Interface::on_checkbutton_instruments_volume_envelope_susloop_clicked);
   label7.set_name("label7");
   label7.set_alignment(0.5, 0.5);
   label7.set_padding(0, 0);
   spinbutton_instruments_volume_envelope_susloop_begin->set_usize(-1, 17);
   spinbutton_instruments_volume_envelope_susloop_begin->set_name("spinbutton_instruments_volume_envelope_susloop_begin");
   spinbutton_instruments_volume_envelope_susloop_begin->set_editable(true);
   hbox33.set_name("hbox33");
   hbox33.pack_start(label7, false, false, 0);
   hbox33.pack_end(*spinbutton_instruments_volume_envelope_susloop_begin, false, false, 0);
   label74.set_name("label74");
   label74.set_alignment(0.5, 0.5);
   label74.set_padding(0, 0);
   spinbutton_instruments_volume_envelope_susloop_end->set_usize(-1, 17);
   spinbutton_instruments_volume_envelope_susloop_end->set_name("spinbutton_instruments_volume_envelope_susloop_end");
   spinbutton_instruments_volume_envelope_susloop_end->set_editable(true);
   hbox34.set_name("hbox34");
   hbox34.pack_start(label74, false, false, 0);
   hbox34.pack_end(*spinbutton_instruments_volume_envelope_susloop_end, false, false, 0);
   vbox14.set_name("vbox14");
   vbox14.pack_start(checkbutton_instruments_volume_envelope, false, false, 0);
   vbox14.pack_start(checkbutton_instruments_volume_envelope_carry, false, false, 0);
   vbox14.pack_start(hseparator29);
   vbox14.pack_start(checkbutton_instruments_volume_envelope_loop, false, false, 0);
   vbox14.pack_start(hbox31, true, true, 3);
   vbox14.pack_start(hbox32, true, true, 3);
   vbox14.pack_start(hseparator30);
   vbox14.pack_start(checkbutton_instruments_volume_envelope_susloop, false, false, 0);
   vbox14.pack_start(hbox33, true, true, 3);
   vbox14.pack_start(hbox34, true, true, 3);
   frame20.set_name("frame20");
   frame20.set_label_align(0, 0);
   frame20.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame20.add(vbox14);
   spinbutton_instruments_volume_global.set_name("spinbutton_instruments_volume_global");
   spinbutton_instruments_volume_global.set_alignment(0.5, 0.5);
   spinbutton_instruments_volume_global.set_padding(0, 0);
   label76.set_name("label76");
   label76.set_alignment(0.5, 0.5);
   label76.set_padding(0, 0);
   label77.set_name("label77");
   label77.set_alignment(0.5, 0.5);
   label77.set_padding(0, 0);
   spinbutton_instruments_global_volume->set_name("spinbutton_instruments_global_volume");
   spinbutton_instruments_global_volume->set_editable(true);
   spinbutton_instruments_volume_fadeout->set_name("spinbutton_instruments_volume_fadeout");
   spinbutton_instruments_volume_fadeout->set_editable(true);
   spinbutton_instruments_volume_swing->set_name("spinbutton_instruments_volume_swing");
   spinbutton_instruments_volume_swing->set_editable(true);
   table8.set_name("table8");
   table8.attach(spinbutton_instruments_volume_global, 0, 1, 0, 1, 0, 0, 0, 0);
   table8.attach(label76, 0, 1, 1, 2, 0, 0, 0, 0);
   table8.attach(label77, 0, 1, 2, 3, 0, 0, 0, 0);
   table8.attach(*spinbutton_instruments_global_volume, 1, 2, 0, 1, 0, 0, 0, 0);
   table8.attach(*spinbutton_instruments_volume_fadeout, 1, 2, 1, 2, 0, 0, 0, 0);
   table8.attach(*spinbutton_instruments_volume_swing, 1, 2, 2, 3, 0, 0, 0, 0);
   frame21.set_name("frame21");
   frame21.set_label_align(0, 0);
   frame21.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame21.add(table8);
   vbox13.set_name("vbox13");
   vbox13.pack_start(frame19);
   vbox13.pack_start(frame20);
   vbox13.pack_start(frame21);
   viewport3.set_name("viewport3");
   viewport3.add(vbox13);
   scrolledwindow9.set_name("scrolledwindow9");
   scrolledwindow9.set_policy(GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
   scrolledwindow9.add(viewport3);
   viewport2.set_name("viewport2");
   viewport2.add(scrolledwindow9);
   label47.set_name("label47");
   label47.set_alignment(0.5, 0.5);
   label47.set_padding(0, 0);
   envelope_instruments_pan.set_usize(-1, 100);
   frame14.set_name("frame14");
   frame14.set_label_align(0, 0);
   frame14.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame14.add(envelope_instruments_pan);
   checkbutton_instruments_pan_envelope.set_usize(-1, 17);
   checkbutton_instruments_pan_envelope.set_name("checkbutton_instruments_pan_envelope");
   connect_to_method(checkbutton_instruments_pan_envelope.clicked, (Interface*)this, &Interface::on_checkbutton_instruments_pan_envelope_clicked);
   checkbutton_instruments_pan_envelope_carry.set_usize(-1, 17);
   checkbutton_instruments_pan_envelope_carry.set_name("checkbutton_instruments_pan_envelope_carry");
   connect_to_method(checkbutton_instruments_pan_envelope_carry.clicked, (Interface*)this, &Interface::on_checkbutton_instruments_pan_envelope_carry_clicked);
   hseparator26.set_name("hseparator26");
   checkbutton_instruments_pan_envelope_loop.set_usize(-1, 17);
   checkbutton_instruments_pan_envelope_loop.set_name("checkbutton_instruments_pan_envelope_loop");
   connect_to_method(checkbutton_instruments_pan_envelope_loop.clicked, (Interface*)this, &Interface::on_checkbutton_instruments_pan_envelope_loop_clicked);
   spinbutton_instruments_pan_envelope_loop_begin->set_usize(-1, 17);
   spinbutton_instruments_pan_envelope_loop_begin->set_name("spinbutton_instruments_pan_envelope_loop_begin");
   spinbutton_instruments_pan_envelope_loop_begin->set_editable(true);
   label60.set_name("label60");
   label60.set_alignment(0.5, 0.5);
   label60.set_padding(0, 0);
   hbox24.set_name("hbox24");
   hbox24.pack_end(*spinbutton_instruments_pan_envelope_loop_begin, false, false, 0);
   hbox24.pack_start(label60, false, false, 0);
   label61.set_name("label61");
   label61.set_alignment(0.5, 0.5);
   label61.set_padding(0, 0);
   spinbutton_instruments_pan_envelope_loop_end->set_usize(-1, 17);
   spinbutton_instruments_pan_envelope_loop_end->set_name("spinbutton_instruments_pan_envelope_loop_end");
   spinbutton_instruments_pan_envelope_loop_end->set_editable(true);
   hbox25.set_name("hbox25");
   hbox25.pack_start(label61, false, false, 0);
   hbox25.pack_end(*spinbutton_instruments_pan_envelope_loop_end, false, false, 0);
   hseparator27.set_name("hseparator27");
   checkbutton_instruments_pan_envelope_susloop.set_usize(-1, 17);
   checkbutton_instruments_pan_envelope_susloop.set_name("checkbutton_instruments_pan_envelope_susloop");
   connect_to_method(checkbutton_instruments_pan_envelope_susloop.clicked, (Interface*)this, &Interface::on_checkbutton_instruments_pan_envelope_susloop_add);
   label62.set_name("label62");
   label62.set_alignment(0.5, 0.5);
   label62.set_padding(0, 0);
   spinbutton_instruments_pan_envelope_susloop_begin->set_usize(-1, 17);
   spinbutton_instruments_pan_envelope_susloop_begin->set_name("spinbutton_instruments_pan_envelope_susloop_begin");
   spinbutton_instruments_pan_envelope_susloop_begin->set_editable(true);
   hbox26.set_name("hbox26");
   hbox26.pack_start(label62, false, false, 0);
   hbox26.pack_end(*spinbutton_instruments_pan_envelope_susloop_begin, false, false, 0);
   label63.set_name("label63");
   label63.set_alignment(0.5, 0.5);
   label63.set_padding(0, 0);
   spinbutton_instruments_pan_envelope_susloop_end->set_usize(-1, 17);
   spinbutton_instruments_pan_envelope_susloop_end->set_name("spinbutton_instruments_pan_envelope_susloop_end");
   spinbutton_instruments_pan_envelope_susloop_end->set_editable(true);
   hbox27.set_name("hbox27");
   hbox27.pack_start(label63, false, false, 0);
   hbox27.pack_end(*spinbutton_instruments_pan_envelope_susloop_end, false, false, 0);
   vbox11.set_name("vbox11");
   vbox11.pack_start(checkbutton_instruments_pan_envelope, false, false, 0);
   vbox11.pack_start(checkbutton_instruments_pan_envelope_carry, false, false, 0);
   vbox11.pack_start(hseparator26);
   vbox11.pack_start(checkbutton_instruments_pan_envelope_loop, false, false, 0);
   vbox11.pack_start(hbox24);
   vbox11.pack_start(hbox25);
   vbox11.pack_start(hseparator27);
   vbox11.pack_start(checkbutton_instruments_pan_envelope_susloop, false, false, 0);
   vbox11.pack_start(hbox26);
   vbox11.pack_start(hbox27);
   frame15.set_name("frame15");
   frame15.set_label_align(0, 0);
   frame15.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame15.add(vbox11);
   label82.set_name("label82");
   label82.set_alignment(0.5, 0.5);
   label82.set_padding(0, 0);
   spinbutton_instruments_pan_default_value->set_usize(-1, 17);
   spinbutton_instruments_pan_default_value->set_name("spinbutton_instruments_pan_default_value");
   spinbutton_instruments_pan_default_value->set_editable(true);
   spinbutton_instruments_pan_swing->set_usize(-1, 17);
   spinbutton_instruments_pan_swing->set_name("spinbutton_instruments_pan_swing");
   spinbutton_instruments_pan_swing->set_editable(true);
   checkbutton_instruments_pan_default.set_name("checkbutton_instruments_pan_default");
   connect_to_method(checkbutton_instruments_pan_default.clicked, (Interface*)this, &Interface::on_checkbutton_instruments_pan_default_clicked);
   hseparator33.set_name("hseparator33");
   spinbutton_instruments_pitch_pan_separation->set_usize(-1, 17);
   spinbutton_instruments_pitch_pan_separation->set_name("spinbutton_instruments_pitch_pan_separation");
   spinbutton_instruments_pitch_pan_separation->set_editable(true);
   label83.set_name("label83");
   label83.set_alignment(0.5, 0.5);
   label83.set_padding(0, 0);
   spinbutton_instruments_pan_pitch_center->set_name("spinbutton_instruments_pan_pitch_center");
   spinbutton_instruments_pan_pitch_center->set_editable(true);
   hbox37.set_name("hbox37");
   hbox37.pack_start(label83, false, false, 0);
   hbox37.pack_start(*spinbutton_instruments_pan_pitch_center);
   entry_instruments_pan_pitch_center.set_name("entry_instruments_pan_pitch_center");
   entry_instruments_pan_pitch_center.set_editable(false);
   label84.set_name("label84");
   label84.set_alignment(0.5, 0.5);
   label84.set_padding(0, 0);
   label85.set_name("label85");
   label85.set_alignment(0.5, 0.5);
   label85.set_padding(0, 0);
   table10.set_name("table10");
   table10.attach(label82, 0, 1, 1, 2, 0, 0, 0, 0);
   table10.attach(*spinbutton_instruments_pan_default_value, 1, 2, 1, 2, 0, 0, 0, 0);
   table10.attach(*spinbutton_instruments_pitch_pan_separation, 1, 2, 3, 4, 0, 0, 0, 0);
   table10.attach(checkbutton_instruments_pan_default, 1, 2, 0, 1, 0, 0, 0, 0);
   table10.attach(hseparator33, 0, 1, 0, 1, GTK_FILL, GTK_FILL, 0, 0);
   table10.attach(*spinbutton_instruments_pan_swing, 1, 2, 4, 5, 0, 0, 0, 0);
   table10.attach(hbox37, 0, 1, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
   table10.attach(entry_instruments_pan_pitch_center, 1, 2, 2, 3, 0, 0, 0, 2);
   table10.attach(label84, 0, 1, 3, 4, 0, 0, 0, 2);
   table10.attach(label85, 0, 1, 4, 5, 0, 0, 0, 0);
   frame23.set_name("frame23");
   frame23.set_label_align(0, 0);
   frame23.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame23.add(table10);
   vbox10.set_name("vbox10");
   vbox10.pack_start(frame14);
   vbox10.pack_start(frame15);
   vbox10.pack_start(frame23);
   viewport4.set_name("viewport4");
   viewport4.add(vbox10);
   scrolledInterface0.set_name("scrolledInterface0");
   scrolledInterface0.set_policy(GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
   scrolledInterface0.add(viewport4);
   label48.set_name("label48");
   label48.set_alignment(0.5, 0.5);
   label48.set_padding(0, 0);
   envelope_instruments_frequency.set_usize(-1, 100);
   envelope_instruments_frequency.set_name("envelope_instruments_frequency");
   frame24.set_name("frame24");
   frame24.set_label_align(0, 0);
   frame24.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame24.add(envelope_instruments_frequency);
   label94.set_name("label94");
   label94.set_alignment(0.5, 0.5);
   label94.set_padding(0, 0);

   combo_instruments_frequency_envelope_type.set_name("combo_instruments_frequency_envelope_type");
   {

      const char *items[] = { "Off","On Pitch","On Filter", 0 };
      combo_instruments_frequency_envelope_type.set_popdown_strings(items);

   }
   combo_instruments_frequency_envelope_type.get_entry()->set_name("combo-entry3");
   combo_instruments_frequency_envelope_type.get_entry()->set_editable(true);
   combo_instruments_frequency_envelope_type.get_entry()->set_text("Off");
   hbox43.set_name("hbox43");
//   hbox43.pack_start(label94, false, false, 0);
   hbox43.pack_start(checkbutton_instruments_pitch_envelope);
   hbox43.pack_start(checkbutton_instruments_pitch_envelope_filter);

   checkbutton_instruments_frequency_envelope_carry.set_usize(-1, 17);
   checkbutton_instruments_frequency_envelope_carry.set_name("checkbutton_instruments_frequency_envelope_carry");
   connect_to_method(checkbutton_instruments_frequency_envelope_carry.clicked, (Interface*)this, &Interface::on_checkbutton_instruments_frequency_envelope_carry_clicked);
   hseparator34.set_name("hseparator34");
   checkbutton_instruments_frequency_envelope_loop.set_usize(-1, 17);
   checkbutton_instruments_frequency_envelope_loop.set_name("checkbutton_instruments_frequency_envelope_loop");
   connect_to_method(checkbutton_instruments_frequency_envelope_loop.clicked, (Interface*)this, &Interface::on_checkbutton_instruments_frequency_envelope_loop_clicked);
   spinbutton_instruments_frequency_envelope_loop_begin->set_usize(-1, 17);
   spinbutton_instruments_frequency_envelope_loop_begin->set_name("spinbutton_instruments_frequency_envelope_loop_begin");
   spinbutton_instruments_frequency_envelope_loop_begin->set_editable(true);
   label86.set_name("label86");
   label86.set_alignment(0.5, 0.5);
   label86.set_padding(0, 0);
   hbox38.set_name("hbox38");
   hbox38.pack_end(*spinbutton_instruments_frequency_envelope_loop_begin, false, false, 0);
   hbox38.pack_start(label86, false, false, 0);
   label87.set_name("label87");
   label87.set_alignment(0.5, 0.5);
   label87.set_padding(0, 0);
   spinbutton_instruments_frequency_envelope_loop_end->set_usize(-1, 17);
   spinbutton_instruments_frequency_envelope_loop_end->set_name("spinbutton_instruments_frequency_envelope_loop_end");
   spinbutton_instruments_frequency_envelope_loop_end->set_editable(true);
   hbox39.set_name("hbox39");
   hbox39.pack_start(label87, false, false, 0);
   hbox39.pack_end(*spinbutton_instruments_frequency_envelope_loop_end, false, false, 0);
   hseparator35.set_name("hseparator35");
   checkbutton_instruments_frequency_envelope_susloop.set_usize(-1, 17);
   checkbutton_instruments_frequency_envelope_susloop.set_name("checkbutton_instruments_frequency_envelope_susloop");
   connect_to_method(checkbutton_instruments_frequency_envelope_susloop.clicked, (Interface*)this, &Interface::on_checkbutton_instruments_frequency_envelope_susloop_clicked);
   label88.set_name("label88");
   label88.set_alignment(0.5, 0.5);
   label88.set_padding(0, 0);
   spinbutton_instruments_frequency_envelope_susloop_begin->set_usize(-1, 17);
   spinbutton_instruments_frequency_envelope_susloop_begin->set_name("spinbutton_instruments_frequency_envelope_susloop_begin");
   spinbutton_instruments_frequency_envelope_susloop_begin->set_editable(true);
   hbox40.set_name("hbox40");
   hbox40.pack_start(label88, false, false, 0);
   hbox40.pack_end(*spinbutton_instruments_frequency_envelope_susloop_begin, false, false, 0);
   label89.set_name("label89");
   label89.set_alignment(0.5, 0.5);
   label89.set_padding(0, 0);
   spinbutton_instruments_frequency_envelope_susloop_end->set_usize(-1, 17);
   spinbutton_instruments_frequency_envelope_susloop_end->set_name("spinbutton_instruments_frequency_envelope_susloop_end");
   spinbutton_instruments_frequency_envelope_susloop_end->set_editable(true);
   hbox41.set_name("hbox41");
   hbox41.pack_start(label89, false, false, 0);
   hbox41.pack_end(*spinbutton_instruments_frequency_envelope_susloop_end, false, false, 0);
   vbox16.set_name("vbox16");
   vbox16.pack_start(hbox43, false, false, 0);
   vbox16.pack_start(checkbutton_instruments_frequency_envelope_carry, false, false, 0);
   vbox16.pack_start(hseparator34);
   vbox16.pack_start(checkbutton_instruments_frequency_envelope_loop, false, false, 0);
   vbox16.pack_start(hbox38, true, true, 3);
   vbox16.pack_start(hbox39, true, true, 3);
   vbox16.pack_start(hseparator35, true, true, 6);
   vbox16.pack_start(checkbutton_instruments_frequency_envelope_susloop, false, false, 0);
   vbox16.pack_start(hbox40, true, true, 5);
   vbox16.pack_start(hbox41, true, true, 3);

   checkbutton_instruments_use_default_cutoff.show();
   checkbutton_instruments_use_default_Q.show();
   hbox_filter_cutoff.show();
   hbox_filter_Q.show();

   spinbutton_instruments_default_cutoff->set_usize(50, 17);
   spinbutton_instruments_default_Q->set_usize(50, 17);
   hbox_filter_cutoff.pack_start(checkbutton_instruments_use_default_cutoff,false,false,0);
   hbox_filter_cutoff.pack_end(*spinbutton_instruments_default_cutoff,false,false,0);
   hbox_filter_Q.pack_start(checkbutton_instruments_use_default_Q,false,false,0);
   hbox_filter_Q.pack_end(*spinbutton_instruments_default_Q,false,false,0);

   spinbutton_instruments_default_cutoff_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_default_cutoff_adj_changed));
   checkbutton_instruments_use_default_cutoff.clicked.connect(slot(this,&Interface::on_checkbutton_instruments_use_default_cutoff_clicked));

   spinbutton_instruments_default_Q_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_default_Q_adj_changed));
   checkbutton_instruments_use_default_Q.clicked.connect(slot(this,&Interface::on_checkbutton_instruments_use_default_Q_clicked));




   ergh.show();
   vbox16.pack_start(ergh, true, true, 3);
   vbox16.pack_start(hbox_filter_cutoff, true, true, 3);
   vbox16.pack_start(hbox_filter_Q, true, true, 3);


   frame25.set_name("frame25");
   frame25.set_label_align(0, 0);
   frame25.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame25.add(vbox16);
   label90.set_name("label90");
   label90.set_alignment(0.5, 0.5);
   label90.set_padding(0, 0);
   spinbutton49->set_usize(-1, 17);
   spinbutton49->set_name("spinbutton49");
   spinbutton49->set_editable(true);
   spinbutton50->set_usize(-1, 17);
   spinbutton50->set_name("spinbutton50");
   spinbutton50->set_editable(true);
   checkbutton25.set_name("checkbutton25");
   hseparator36.set_name("hseparator36");
   spinbutton51->set_usize(-1, 17);
   spinbutton51->set_name("spinbutton51");
   spinbutton51->set_editable(true);
   label91.set_name("label91");
   label91.set_alignment(0.5, 0.5);
   label91.set_padding(0, 0);
   spinbutton52->set_name("spinbutton52");
   spinbutton52->set_editable(true);
   hbox42.set_name("hbox42");
   hbox42.pack_start(label91, false, false, 0);
   hbox42.pack_start(*spinbutton52);
   entry19.set_name("entry19");
   entry19.set_editable(false);
   label92.set_name("label92");
   label92.set_alignment(0.5, 0.5);
   label92.set_padding(0, 0);
   label93.set_name("label93");
   label93.set_alignment(0.5, 0.5);
   label93.set_padding(0, 0);
   table11.set_name("table11");
   table11.attach(label90, 0, 1, 1, 2, 0, 0, 0, 0);
   table11.attach(*spinbutton49, 1, 2, 1, 2, 0, 0, 0, 0);
   table11.attach(*spinbutton50, 1, 2, 3, 4, 0, 0, 0, 0);
   table11.attach(checkbutton25, 1, 2, 0, 1, 0, 0, 0, 0);
   table11.attach(hseparator36, 0, 1, 0, 1, GTK_FILL, GTK_FILL, 0, 0);
   table11.attach(*spinbutton51, 1, 2, 4, 5, 0, 0, 0, 0);
   table11.attach(hbox42, 0, 1, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
   table11.attach(entry19, 1, 2, 2, 3, 0, 0, 0, 2);
   table11.attach(label92, 0, 1, 3, 4, 0, 0, 0, 2);
   table11.attach(label93, 0, 1, 4, 5, 0, 0, 0, 0);
   frame26.set_name("frame26");
   frame26.set_label_align(0, 0);
   frame26.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame26.add(table11);
   vbox15.set_name("vbox15");
   vbox15.pack_start(frame24);
   vbox15.pack_start(frame25);
   vbox15.pack_start(frame26);
   viewport5.set_name("viewport5");
   viewport5.add(vbox15);
   scrolledInterface1.set_name("scrolledInterface1");
   scrolledInterface1.set_policy(GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
   scrolledInterface1.add(viewport5);
   label49.set_name("label49");
   label49.set_alignment(0.5, 0.5);
   label49.set_padding(0, 0);
   notebook2.set_name("notebook2");
   notebook2.set_show_tabs(true);
   notebook2.set_tab_border(3);
   notebook2.append_page(hbox18, label46);
   notebook2.append_page(viewport2, label47);
   notebook2.append_page(scrolledInterface0, label48);
   notebook2.append_page(scrolledInterface1, label49);
   hbox17.set_name("hbox17");
   hbox17.pack_start(frame9);
   hbox17.pack_start(notebook2);
   label3.set_name("label3");
   label3.set_alignment(0.5, 0.5);
   label3.set_padding(0, 0);
   label4.set_name("label4");
   label4.set_alignment(0.5, 0.5);
   label4.set_padding(0, 0);
//   orderlist_ord_pan.set_name("orderlist_ord_pan");
//   orderlist_ord_pan.set_alignment(0.5, 0.5);
//   orderlist_ord_pan.set_padding(0, 0);
   frame27.set_name("frame27");
   frame27.set_label_align(0, 0);
   frame27.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   orderlist_viewport.add(orderlist_ord_pan);
   frame27.add(orderlist_viewport);
   orderlist_viewport.show();
   vseparator7.set_name("vseparator7");
   hseparator37.set_name("hseparator37");

   vbox17.set_name("vbox17");
   vbox17.pack_start(hseparator37, false, false, 3);

	for (int i=0;i<PATTERN_WIDTH;i++) {

		char channel_num[13]={'C','h','a','n','n','e','l',' ','0','0',':',' ',0} ;

		channel_num[8]='0'+(i+1)/10;		
		channel_num[9]='0'+(i+1)%10;		

		panvol_defaults[i].vseparator9.show();
		panvol_defaults[i].checkbutton_order_pan_surround.show();
		panvol_defaults[i].checkbutton_order_pan_mute.show();
		panvol_defaults[i].vseparator8.show();

		panvol_defaults[i].hbox45.set_name("hbox45");
		panvol_defaults[i].hbox45.show();

		panvol_defaults[i].spinbutton_order_pan_pan_adj = new Gtk::Adjustment(0, 0, 64, 1, 10, 10);
		panvol_defaults[i].spinbutton_order_pan_pan = new Scroll_Bar(*panvol_defaults[i].spinbutton_order_pan_pan_adj);
		panvol_defaults[i].spinbutton_order_pan_volume_adj = new Gtk::Adjustment(0, 0, 64, 1, 10, 10);
		panvol_defaults[i].spinbutton_order_pan_volume = new Scroll_Bar(*panvol_defaults[i].spinbutton_order_pan_volume_adj);


		panvol_defaults[i].label96.set_name("label96");
		panvol_defaults[i].label96.set_alignment(0.5, 0.5);
		panvol_defaults[i].label96.set_padding(0, 0);
		panvol_defaults[i].label96.set_text("Pan:  ");
		panvol_defaults[i].label96.show();

		panvol_defaults[i].spinbutton_order_pan_pan->set_usize(52, -1);
		panvol_defaults[i].spinbutton_order_pan_pan->set_name("spinbutton_order_pan_pan");

		panvol_defaults[i].spinbutton_order_pan_pan->show();
		panvol_defaults[i].spinbutton_order_pan_volume->show();

		panvol_defaults[i].label_order_pan_number.set_text(channel_num);
		panvol_defaults[i].label_order_pan_number.set_alignment(0.5, 0.5);
		panvol_defaults[i].label_order_pan_number.set_padding(0, 0);
		panvol_defaults[i].label_order_pan_number.show();

		panvol_defaults[i].label97.set_name("label97");
		panvol_defaults[i].label97.set_alignment(0.5, 0.5);
		panvol_defaults[i].label97.set_padding(0, 0);
		panvol_defaults[i].label97.set_text("Vol:  ");
		panvol_defaults[i].label97.show();

		panvol_defaults[i].hbox45.pack_start(panvol_defaults[i].label_order_pan_number, false, false, 0);
		panvol_defaults[i].hbox45.pack_start(panvol_defaults[i].vseparator9, false, false, 2);
		panvol_defaults[i].hbox45.pack_start(panvol_defaults[i].label96, false, false, 0);
		panvol_defaults[i].hbox45.pack_start(*panvol_defaults[i].spinbutton_order_pan_pan, true, true, 0);
		panvol_defaults[i].hbox45.pack_start(panvol_defaults[i].checkbutton_order_pan_surround, false, false, 0);
		panvol_defaults[i].hbox45.pack_start(panvol_defaults[i].vseparator8, false, false, 3);
		panvol_defaults[i].hbox45.pack_start(panvol_defaults[i].label97, false, false, 0);
		panvol_defaults[i].hbox45.pack_start(*panvol_defaults[i].spinbutton_order_pan_volume, true, true, 0);
		panvol_defaults[i].hbox45.pack_start(panvol_defaults[i].checkbutton_order_pan_mute, false, false, 0);
                panvol_defaults[i].hbox45.show();


		panvol_defaults[i].spinbutton_order_pan_pan_adj->value_changed.connect(bind<int>(slot(this,&Interface::on_orderpan_pan_changed),i));
		panvol_defaults[i].spinbutton_order_pan_volume_adj->value_changed.connect(bind<int>(slot(this,&Interface::on_orderpan_volume_changed),i));
		panvol_defaults[i].checkbutton_order_pan_surround.clicked.connect(bind<int>(slot(this,&Interface::on_orderpan_suround_changed),i));
		panvol_defaults[i].checkbutton_order_pan_mute.clicked.connect(bind<int>(slot(this,&Interface::on_orderpan_mute_changed),i));

		vbox17.pack_start(panvol_defaults[i].hbox45, false, true, 3);
	}



   viewport1.set_name("viewport1");
   viewport1.add(vbox17);
   scrolledwindow7.set_name("scrolledwindow7");
   scrolledwindow7.set_policy(GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
   scrolledwindow7.add(viewport1);
   hbox44.set_name("hbox44");
   hbox44.pack_start(frame27, false, true, 0);
   hbox44.pack_start(vseparator7, false, false, 5);
   hbox44.pack_start(scrolledwindow7);
   label5.set_name("label5");
   label5.set_alignment(0.5, 0.5);
   label5.set_padding(0, 0);
   hseparator38.set_name("hseparator38");
   label98.set_name("label98");
   label98.set_alignment(0.5, 0.5);
   label98.set_padding(0, 0);
   spinbutton_variables_tempo->set_name("spinbutton_variables_tempo");
   spinbutton_variables_tempo->set_editable(true);
   hbox46.set_name("hbox46");
   hbox46.pack_start(label98, false, false, 0);
   hbox46.pack_start(*spinbutton_variables_tempo, false, false, 0);
   label99.set_name("label99");
   label99.set_alignment(0.5, 0.5);
   label99.set_padding(0, 0);
   spinbutton_variables_speed->set_name("spinbutton_variables_speed");
   spinbutton_variables_speed->set_editable(true);
   hbox47.set_name("hbox47");
   hbox47.pack_start(label99, false, false, 0);
   hbox47.pack_start(*spinbutton_variables_speed, false, false, 0);
   vbox19.set_name("vbox19");
   vbox19.set_border_width(8);
   vbox19.pack_start(hbox46);
   vbox19.pack_start(hbox47);
   frame28.set_name("frame28");
   frame28.set_border_width(5);
   frame28.set_label_align(0, 0);
   frame28.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame28.add(vbox19);
   hseparator39.set_name("hseparator39");
   label100.set_name("label100");
   label100.set_alignment(0.5, 0.5);
   label100.set_padding(0, 0);
   spinbutton_variables_glb_volume->set_name("spinbutton_variables_glb_volume");
   spinbutton_variables_glb_volume->set_editable(true);
   hbox48.set_name("hbox48");
   hbox48.pack_start(label100, false, false, 0);
   hbox48.pack_start(*spinbutton_variables_glb_volume, false, false, 0);
   label101.set_name("label101");
   label101.set_alignment(0.5, 0.5);
   label101.set_padding(0, 0);
   spinbutton_variables_mix_volume->set_name("spinbutton_variables_mix_volume");
   spinbutton_variables_mix_volume->set_editable(true);
   hbox49.set_name("hbox49");
   hbox49.pack_start(label101, false, false, 0);
   hbox49.pack_start(*spinbutton_variables_mix_volume, false, false, 0);
   label102.set_name("label102");
   label102.set_alignment(0.5, 0.5);
   label102.set_padding(0, 0);
   spinbutton_variables_stereo_separation->set_name("spinbutton_variables_stereo_separation");
   spinbutton_variables_stereo_separation->set_editable(true);
   hbox50.set_name("hbox50");
   hbox50.pack_start(label102, false, false, 0);
   hbox50.pack_start(*spinbutton_variables_stereo_separation, false, false, 0);
   checkbutton_variables_old_effects.set_name("checkbutton_variables_old_effects");
   connect_to_method(checkbutton_variables_old_effects.clicked, (Interface*)this, &Interface::on_checkbutton_variables_old_effects_clicked);
   checkbutton_variables_compat_gxx.set_name("checkbutton_variables_compat_gxx");
   connect_to_method(checkbutton_variables_compat_gxx.clicked, (Interface*)this, &Interface::on_checkbutton_variables_compat_gxx_clicked);
   vbox20.set_name("vbox20");
   vbox20.set_border_width(4);
   vbox20.pack_start(hbox48);
   vbox20.pack_start(hbox49);
   vbox20.pack_start(hbox50);
   vbox20.pack_start(checkbutton_variables_old_effects, false, false, 0);
   vbox20.pack_start(checkbutton_variables_compat_gxx, false, false, 0);
   frame29.set_name("frame29");
   frame29.set_border_width(5);
   frame29.set_label_align(0, 0);
   frame29.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame29.add(vbox20);
   hseparator40.set_name("hseparator40");
   label103.set_name("label103");
   label103.set_alignment(0.5, 0.5);
   label103.set_padding(0, 0);
   radiobutton_variables_control_instruments->set_name("radiobutton_variables_control_instruments");
   connect_to_method(radiobutton_variables_control_instruments->clicked, (Interface*)this, &Interface::on_radiobutton_variables_control_instruments_clicked);
   radiobutton_variables_control_samples->set_name("radiobutton_variables_control_samples");
   connect_to_method(radiobutton_variables_control_samples->clicked, (Interface*)this, &Interface::on_radiobutton_variables_control_samples_clicked);
   hbox52.set_name("hbox52");
   hbox52.pack_start(label103, false, false, 0);
   hbox52.pack_start(*radiobutton_variables_control_instruments, false, false, 0);
   hbox52.pack_start(*radiobutton_variables_control_samples, false, false, 0);
   label104.set_name("label104");
   label104.set_alignment(0.5, 0.5);
   label104.set_padding(0, 0);
   radiobutton_variables_playback_stereo->set_name("radiobutton_variables_playback_stereo");
   connect_to_method(radiobutton_variables_playback_stereo->clicked, (Interface*)this, &Interface::on_radiobutton_variables_playback_stereo_clicked);
   radiobutton_variables_playback_mono->set_name("radiobutton_variables_playback_mono");
   connect_to_method(radiobutton_variables_playback_mono->clicked, (Interface*)this, &Interface::on_radiobutton_variables_playback_mono_clicked);
   hbox53.set_name("hbox53");
   hbox53.pack_start(label104, false, false, 0);
   hbox53.pack_start(*radiobutton_variables_playback_stereo, false, false, 0);
   hbox53.pack_start(*radiobutton_variables_playback_mono, false, false, 0);
   label105.set_name("label105");
   label105.set_alignment(0.5, 0.5);
   label105.set_padding(0, 0);
   radiobutton_variables_slides_linear->set_name("radiobutton_variables_slides_linear");
   connect_to_method(radiobutton_variables_slides_linear->clicked, (Interface*)this, &Interface::on_radiobutton_variables_slides_linear_clicked);
   radiobutton_variables_slides_amiga->set_name("radiobutton_variables_slides_amiga");
   connect_to_method(radiobutton_variables_slides_amiga->clicked, (Interface*)this, &Interface::on_radiobutton_variables_slides_amiga_clicked);
   hbox54.set_name("hbox54");
   hbox54.pack_start(label105, false, false, 0);
   hbox54.pack_start(*radiobutton_variables_slides_linear, false, false, 0);
   hbox54.pack_start(*radiobutton_variables_slides_amiga, false, false, 0);
   vbox21.set_name("vbox21");
   vbox21.set_border_width(7);
   vbox21.pack_start(hbox52);
   vbox21.pack_start(hbox53);
   vbox21.pack_start(hbox54);
   frame30.set_name("frame30");
   frame30.set_border_width(5);
   frame30.set_label_align(0, 0);
   frame30.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame30.add(vbox21);
   vbox18.set_name("vbox18");
   vbox18.pack_start(hseparator38);
   vbox18.pack_start(frame28);
   vbox18.pack_start(hseparator39);
   vbox18.pack_start(frame29);
   vbox18.pack_start(hseparator40);
   vbox18.pack_start(frame30);
   viewport7.set_name("viewport7");
   viewport7.add(vbox18);
   scrolledInterface3.set_name("scrolledInterface3");
   scrolledInterface3.set_policy(GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
   scrolledInterface3.add(viewport7);
   vseparator11.set_name("vseparator11");
   text_variables_message.set_name("text_variables_message");
   text_variables_message.set_editable(true);
   text_variables_message.set_word_wrap(false);
   text_variables_message.set_point(0);

   scrolledInterface4.set_name("scrolledInterface4");
   scrolledInterface4.set_border_width(7);
   scrolledInterface4.set_policy(GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
   scrolledInterface4.add(text_variables_message);
   frame31.set_name("frame31");
   frame31.set_border_width(2);
   frame31.set_label_align(0, 0);
   frame31.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame31.add(scrolledInterface4);
   hbox58.set_name("hbox58");
   hbox58.pack_start(scrolledInterface3, false, false, 0);
   hbox58.pack_start(vseparator11, false, false, 7);
   hbox58.pack_start(frame31);
   label18.set_name("label18");
   label18.set_alignment(0.5, 0.5);
   label18.set_padding(0, 0);
   label19.set_name("label19");
   label19.set_alignment(0.5, 0.5);
   label19.set_padding(0, 0);
   notebook_main.set_name("notebook_main");
   notebook_main.set_show_tabs(true);
   notebook_main.set_tab_border(3);
   notebook_main.append_page(tracker_viewport, label1);
   notebook_main.append_page(hbox6, label2);
   notebook_main.append_page(hbox17, label3);
   notebook_main.append_page(info_split, label4);
   info1_viewport.add(view_data);
   info2_viewport.add(view_pattern);	
   info_split.pack1(info1_viewport,true,false);
   info_split.pack2(info2_viewport,false,false);
   info1_viewport.show();
   info2_viewport.show();

   info_split.show();
   view_pattern.show();	
   info_split.set_position(150);
   notebook_main.append_page(hbox44, label5);
   notebook_main.append_page(hbox58, label18);
//   notebook_main.append_page(widgetwcmwchq, label19);
   statusbar_main_lower.set_name("statusbar_main_lower");
   vbox1.set_name("vbox1");
   vbox1.pack_start(hbox1, false, false, 0);
   vbox1.pack_start(entry_main_upper, false, false, 0);
   vbox1.pack_start(notebook_main);
   vbox1.pack_start(statusbar_main_lower, false, false, 0);
   set_name("Interface");
   set_title((string)APP_TITLE+" v."+(string)APP_VERSION+" - "+(string)APP_AUTHOR);
   add(vbox1);
   label10.show();
   label11.show();
   label13.show();
   label14.show();
   label12.show();
   view_data.show();
   hbox_sample_options.show();
   entry_main_song_name.show();
   entry_main_file_name.show();
   entry_main_row.show();
   hseparator1.show();
   hbox3.show();
   entry_main_pattern.show();
   hseparator2.show();
   hbox4.show();
   entry_main_order.show();
   hseparator3.show();
   hbox5.show();
   table1.show();
   vseparator1.show();
   label15.show();
   label16.show();
   label17.show();
   entry_main_instrument.show();
   entry_main_octave.show();
   hseparator41.show();
   hbox56.show();
   entry_main_speed_tempo.show();
   hseparator42.show();
   hbox57.show();
   table2.show();
   hseparator18.show();
   button_main_play_prev_pattern.show();
   button_main_stop.show();
   button_main_play.show();
   button_main_play_next_pattern.show();
   vseparator2.show();
   button_main_play_pattern.show();
   button_main_play_custom.show();
   vseparator3.show();
   button_main_help.show();
   hbox2.show();
   vbox2.show();
   hbox1.show();
   entry_main_upper.show();
   tracker.show();
   label1.show();
   clist_samples_list.show();
   scrolledwindow3.show();
   hseparator17.show();
   entry_samples_samplename.show();
   vbox5.show();
   frame1.show();
   vseparator4.show();
   label34.show();
   hseparator14.show();
   hbox13.show();
   label20.show();
   hseparator4.show();
   spinbutton_samples_def_volume->show();
   hbox7.show();
   frame2.show();
   label21.show();
   hseparator5.show();
   spinbutton_samples_glb_volume->show();
   hbox8.show();
   frame3.show();
   checkbutton_samples_def_pan.show();
   hseparator6.show();
   spinbutton_samples_def_pan->show();
   hbox9.show();
   frame4.show();
   label35.show();
   hseparator15.show();
   hbox14.show();
   label22.show();
   hseparator7.show();
   spinbutton_samples_vibrato_speed->show();
   hbox10.show();
   frame5.show();
   label23.show();
   hseparator8.show();
   spinbutton_samples_vibrato_depth->show();
   hbox11.show();
   frame6.show();
   label36.show();
   hseparator16.show();
   spinbutton_samples_vibrato_rate->show();
   hbox16.show();
   frame7.show();
   radiobutton_samples_waveform_saw->show();
   radiobutton_samples_waveform_sine->show();
   radiobutton_samples_waveform_square->show();
   radiobutton_samples_waveform_random->show();
   table4.show();
   frame8.show();
   vbox3.show();
   vseparator10.show();
   label24.show();
   entry_samples_filename.show();
   label25.show();
   spinbutton_samples_speed->show();
   label27.show();
   label28.show();
   spinbutton_samples_loop_begin->show();
   spinbutton_samples_loop_end->show();
   label30.show();
   label31.show();
   spinbutton_samples_susloop_begin->show();
   spinbutton_samples_susloop_end->show();
   hseparator10.show();
   hseparator9.show();
   label32.show();
   label33.show();
   entry_samples_quality.show();
   entry_samples_length.show();
   erwer.show();
   hseparator11.show();
   label38.show();
   combo_samples_loop_type.show();
   label39.show();
   combo_samples_susloop_type.show();
   table3.show();
   sample_view_samples_current.show();
   button_samples_edit.show();
   button_samples_play.hide();
   hbox12.show();
   vbox4.show();
   hbox55.show();
   viewport6.show();
   scrolledInterface2.show();
   hbox6.show();
   label2.show();
   clist_instrments_names.show();
   scrolledwindow2.show();
   hseparator19.show();
   entry_instrument_name.show();
   vbox6.show();
   frame9.show();
   equivtable_instruments.show();
   frame10.show();
   vseparator6.show();
   hseparator20.show();
   label50.show();
   radiobutton_instruments_nna_note_cut->show();
   radiobutton_instruments_nna_note_continue->show();
   radiobutton_instruments_nna_note_off->show();
   radiobutton_instruments_nna_note_fade->show();
   hseparator21.show();
   label51.show();
   radiobutton_instruments_dca_disabled->show();
   radiobutton_instruments_dca_note->show();
   radiobutton_instruments_dca_sample->show();
   radiobutton_instruments_dca_disabled_instrument->show();
   radiobutton_instruments_dca_note_fade->show();
   radiobutton_instruments_dca_note_off->show();
   radiobutton_instruments_dca_note_cut->show();
   hseparator23.show();
   table5.show();
   hseparator22.show();
   label52.show();
   entry_instruments_name.show();
   hbox19.show();
   vbox7.show();
   hbox18.show();
   label46.show();
   envelope_instruments_volume.show();
   frame19.show();
   checkbutton_instruments_volume_envelope.show();
   checkbutton_instruments_volume_envelope_carry.show();
   hseparator29.show();
   checkbutton_instruments_volume_envelope_loop.show();
   spinbutton_instruments_volume_envelope_loop_begin->show();
   label23423.show();
   hbox31.show();
   label234234.show();
   spinbutton_instruments_volume_envelope_loop_end->show();
   hbox32.show();
   hseparator30.show();
   checkbutton_instruments_volume_envelope_susloop.show();
   label7.show();
   spinbutton_instruments_volume_envelope_susloop_begin->show();
   hbox33.show();
   label74.show();
   spinbutton_instruments_volume_envelope_susloop_end->show();
   hbox34.show();
   vbox14.show();
   frame20.show();
   spinbutton_instruments_volume_global.show();
   label76.show();
   label77.show();
   spinbutton_instruments_global_volume->show();
   spinbutton_instruments_volume_fadeout->show();
   spinbutton_instruments_volume_swing->show();
   table8.show();
   frame21.show();
   vbox13.show();
   viewport3.show();
   scrolledwindow9.show();
   viewport2.show();
   label47.show();
   envelope_instruments_pan.show();
   frame14.show();
   checkbutton_instruments_pan_envelope.show();
   checkbutton_instruments_pan_envelope_carry.show();
   hseparator26.show();
   checkbutton_instruments_pan_envelope_loop.show();
   spinbutton_instruments_pan_envelope_loop_begin->show();
   label60.show();
   hbox24.show();
   label61.show();
   spinbutton_instruments_pan_envelope_loop_end->show();

   hbox25.show();
   hseparator27.show();
   checkbutton_instruments_pan_envelope_susloop.show();
   label62.show();
   spinbutton_instruments_pan_envelope_susloop_begin->show();
   hbox26.show();
   label63.show();
   spinbutton_instruments_pan_envelope_susloop_end->show();
   hbox27.show();
   vbox11.show();
   frame15.show();
   label82.show();
   spinbutton_instruments_pan_default_value->show();
   spinbutton_instruments_pan_swing->show();
   checkbutton_instruments_pan_default.show();
   hseparator33.show();
   spinbutton_instruments_pitch_pan_separation->show();
   label83.show();
   spinbutton_instruments_pan_pitch_center->show();
   hbox37.show();
   entry_instruments_pan_pitch_center.show();
   label84.show();
   label85.show();
   table10.show();
   frame23.show();
   vbox10.show();
   viewport4.show();
   scrolledInterface0.show();
   label48.show();
   envelope_instruments_frequency.show();
   frame24.show();
   label94.show();
   combo_instruments_frequency_envelope_type.show();
   hbox43.show();
   checkbutton_instruments_frequency_envelope_carry.show();
   hseparator34.show();
   checkbutton_instruments_frequency_envelope_loop.show();
   spinbutton_instruments_frequency_envelope_loop_begin->show();
   label86.show();
   hbox38.show();
   label87.show();
   spinbutton_instruments_frequency_envelope_loop_end->show();
   hbox39.show();
   hseparator35.show();
   checkbutton_instruments_frequency_envelope_susloop.show();
   label88.show();
   spinbutton_instruments_frequency_envelope_susloop_begin->show();
   hbox40.show();
   label89.show();
   spinbutton_instruments_frequency_envelope_susloop_end->show();
   hbox41.show();
   vbox16.show();
   frame25.show();
   label90.show();
   spinbutton49->show();
   spinbutton50->show();
   checkbutton25.show();
   hseparator36.show();
   spinbutton51->show();
   label91.show();
   spinbutton52->show();
   hbox42.show();
   entry19.show();
   label92.show();
   label93.show();
   table11.show();
//   frame26.show();
   vbox15.show();
   viewport5.show();
   scrolledInterface1.show();
   label49.show();
   notebook2.show();
   hbox17.show();
   label3.show();
   label4.show();
   orderlist_ord_pan.show();
   frame27.show();
   vseparator7.show();
   hseparator37.show();

   vbox17.show();
   viewport1.show();
   scrolledwindow7.show();
   hbox44.show();
   label5.show();
   hseparator38.show();
   label98.show();
   spinbutton_variables_tempo->show();
   hbox46.show();
   label99.show();
   spinbutton_variables_speed->show();
   hbox47.show();
   vbox19.show();
   frame28.show();
   hseparator39.show();
   label100.show();
   spinbutton_variables_glb_volume->show();
   hbox48.show();
   label101.show();
   spinbutton_variables_mix_volume->show();
   hbox49.show();
   label102.show();
   spinbutton_variables_stereo_separation->show();
   hbox50.show();
   checkbutton_variables_old_effects.show();
   checkbutton_variables_compat_gxx.show();
   vbox20.show();
   frame29.show();
   hseparator40.show();
   label103.show();
   radiobutton_variables_control_instruments->show();
   radiobutton_variables_control_samples->show();
   hbox52.show();
   label104.show();
   radiobutton_variables_playback_stereo->show();
   radiobutton_variables_playback_mono->show();
   hbox53.show();
   label105.show();
   radiobutton_variables_slides_linear->show();
   radiobutton_variables_slides_amiga->show();
   hbox54.show();
   vbox21.show();
   frame30.show();
   vbox18.show();
   viewport7.show();
   scrolledInterface3.show();
   vseparator11.show();
   text_variables_message.show();
   scrolledInterface4.show();
   frame31.show();
   hbox58.show();
   label18.show();
   label19.show();
   notebook_main.show();
   statusbar_main_lower.show();
   vbox1.show();
   checkbutton_instruments_pitch_envelope.show();
   checkbutton_instruments_pitch_envelope_filter.show();

   checkbutton_instruments_pitch_envelope.show();
   checkbutton_instruments_pitch_envelope_filter.show();
   spinbutton_samples_base_note->show();
   entry_samples_base_note.show();
   spinbutton_samples_finetune->show();
/* CONFIG SCREEN - ADDED LATER :( */
 spinbutton_config_frequency_adj = new Gtk::Adjustment(1, 0, 48000, 1, 10, 10);
   spinbutton_config_frequency = new Gtk::SpinButton(*spinbutton_config_frequency_adj, 1, 0);
   spinbutton_config_virtual_channels_adj = new Gtk::Adjustment(1, 1, 256, 1, 10, 10);
   spinbutton_config_virtual_channels = new Gtk::SpinButton(*spinbutton_config_virtual_channels_adj, 1, 0);
   spinbutton__config_interface_repaint_adj = new Gtk::Adjustment(1, 1, 10, 1, 10, 10);
   spinbutton__config_interface_repaint = new Gtk::SpinButton(*spinbutton__config_interface_repaint_adj, 1, 0);
   clist_config_sound_driver_name.set_name("clist_config_sound_driver_name");
   clist_config_sound_driver_name.set_column_title(0, "Driver Name");
   clist_config_sound_driver_name.set_column_justification(0, GTK_JUSTIFY_CENTER);
   clist_config_sound_driver_name.set_column_width(0, 80);
   clist_config_sound_driver_name.column_titles_show();
   connect_to_method(clist_config_sound_driver_name.select_row, (Interface*)this, &Interface::on_clist_config_sound_driver_name_select_row);
   scrolledwindow18.set_name("scrolledwindow18");
   scrolledwindow18.set_policy(GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);
   scrolledwindow18.add(clist_config_sound_driver_name);
   hseparator56.set_name("hseparator56");
   hseparator57.set_name("hseparator57");
   checkbutton_config_16bits.set_name("checkbutton_config_16bits");
   connect_to_method(checkbutton_config_16bits.clicked, (Interface*)this, &Interface::on_checkbutton_config_16bits_clicked);
   checkbutton_config_stereo.set_name("checkbutton_config_stereo");
   connect_to_method(checkbutton_config_stereo.clicked, (Interface*)this, &Interface::on_checkbutton_config_stereo_clicked);
   label234243.set_name("label234243");
   label234243.set_alignment(0, 0.5);
   label234243.set_padding(0, 0);
   button_config_sound_restart.set_name("button_config_sound_restart");
   connect_to_method(button_config_sound_restart.clicked, (Interface*)this, &Interface::on_button_config_sound_restart_clicked);
   button_config_sound_config.set_name("button_config_sound_config");
   connect_to_method(button_config_sound_config.clicked, (Interface*)this, &Interface::on_button_config_sound_config_clicked);
   label234244.set_name("label234244");
   label234244.set_alignment(0, 0.5);
   label234244.set_padding(0, 0);
   entry_config_sound_status.set_name("entry_config_sound_status");
   entry_config_sound_status.set_editable(false);
   spinbutton_config_frequency->set_name("spinbutton_config_frequency");
   spinbutton_config_frequency->set_editable(true);
   table15.set_name("table15");
   table15.set_border_width(2);
   table15.attach(scrolledwindow18, 0, 2, 0, 6, GTK_EXPAND|GTK_FILL, GTK_EXPAND|GTK_FILL, 0, 0);
   table15.attach(hseparator56, 2, 3, 0, 1, GTK_FILL, GTK_FILL, 0, 0);
   table15.attach(hseparator57, 2, 3, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
   table15.attach(checkbutton_config_16bits, 3, 4, 1, 2, GTK_FILL, 0, 0, 0);
   table15.attach(checkbutton_config_stereo, 3, 4, 0, 1, GTK_FILL, 0, 0, 0);
   table15.attach(label234243, 2, 3, 2, 3, GTK_FILL, 0, 0, 0);
   table15.attach(button_config_sound_restart, 2, 3, 3, 4, GTK_FILL, GTK_FILL, 0, 0);
   table15.attach(button_config_sound_config, 3, 4, 3, 4, GTK_FILL, GTK_FILL, 0, 0);
   table15.attach(label234244, 2, 3, 4, 5, GTK_FILL, 0, 0, 0);
   table15.attach(entry_config_sound_status, 3, 4, 4, 5, GTK_FILL, GTK_FILL, 0, 0);
   table15.attach(combo_config_frequency, 3, 4, 2, 3, GTK_FILL, 0, 0, 0);
   table15.attach(combo_config_buffersize, 3, 4, 5, 6, GTK_FILL, 0, 0, 0);
   table15.attach(labelbuffsize, 2, 3, 5, 6, GTK_FILL, 0, 0, 0);

   {

      const char *items[] = { "11025","22050","44100","48000", 0 };
      combo_config_frequency.set_popdown_strings(items);
	
   }
   {

      const char *items[] = { "512","1024","2048","8192","16384", 0 };
      combo_config_buffersize.set_popdown_strings(items);
	
   }
   spinbutton_config_virtual_channels_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_config_virtual_channels_changed));
   combo_config_frequency.get_entry()->changed.connect(slot(this,&Interface::on_combo_config_frequency_changed));
   combo_config_buffersize.get_entry()->changed.connect(slot(this,&Interface::on_combo_config_buffersize_changed));

   combo_config_frequency.get_entry()->set_editable(false);
   combo_config_buffersize.get_entry()->set_editable(false);
	
   frame37.set_name("frame37");
   frame37.set_border_width(4);
   frame37.set_label_align(0, 0);
   frame37.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame37.add(table15);
   clist_config_mixer_proc.set_name("clist_config_mixer_proc");
   clist_config_mixer_proc.set_column_title(0, "Mixer Proc.");
   clist_config_mixer_proc.set_column_justification(0, GTK_JUSTIFY_CENTER);
   clist_config_mixer_proc.set_column_width(0, 80);
   clist_config_mixer_proc.column_titles_show();
   connect_to_method(clist_config_mixer_proc.select_row, (Interface*)this, &Interface::on_clist_config_mixer_proc_select_row);
   scrolledwindow19.set_name("scrolledwindow19");
   scrolledwindow19.set_policy(GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);
   scrolledwindow19.add(clist_config_mixer_proc);
   label234246.set_name("label234246");
   label234246.set_alignment(0, 0.5);
   label234246.set_padding(0, 0);
   spinbutton_config_virtual_channels->set_name("spinbutton_config_virtual_channels");
   spinbutton_config_virtual_channels->set_editable(true);
   table16.set_name("table16");
   table16.set_border_width(2);
   table16.attach(scrolledwindow19, 0, 1, 0, 4, GTK_EXPAND|GTK_FILL, GTK_EXPAND|GTK_FILL, 0, 0);
   table16.attach(checkbutton_config_enable_filters,1,2,0,1,GTK_FILL,GTK_FILL,0,0);
   table16.attach(label234246, 1, 2, 2, 3, GTK_FILL, 0, 0, 0);
   table16.attach(checkbutton_config_enable_filters,1,2,0,1,GTK_FILL,GTK_FILL,0,0);
   table16.attach(checkbutton_config_reverb_enabled,1,2,1,2,GTK_FILL,GTK_FILL,0,0);

   table16.attach(*spinbutton_config_virtual_channels, 1, 2, 3, 4, 0, 0, 0, 0);
   checkbutton_config_enable_filters.clicked.connect(slot(this,&Interface::on_button_config_enable_filters_clicked));
   checkbutton_config_reverb_enabled.clicked.connect(slot(this,&Interface::on_button_config_reverb_enabled_clicked));
   checkbutton_config_reverb_enabled.set_active(false);

   checkbutton_config_reverb_enabled.show();

   checkbutton_config_enable_filters.show();
   frame38.set_name("frame38");
   frame38.set_border_width(4);
   frame38.set_label_align(0, 0);
   frame38.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame38.add(table16);
   hbox60.set_name("hbox60");
   hbox60.pack_start(frame37);
   hbox60.pack_start(frame38);
   frame36.set_name("frame36");
   frame36.set_label_align(0, 0);
   frame36.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame36.add(hbox60);
   label234247.set_name("label234247");
   label234247.set_alignment(0, 0.5);
   label234247.set_padding(0, 0);
   spinbutton__config_interface_repaint->set_name("spinbutton__config_interface_repaint");
   spinbutton__config_interface_repaint->set_editable(true);
   hseparator58.set_name("hseparator58");
   hseparator59.set_name("hseparator59");
   hseparator60.set_name("hseparator60");
   hseparator61.set_name("hseparator61");
   vseparator15.set_name("vseparator15");
   vseparator16.set_name("vseparator16");
   vseparator17.set_name("vseparator17");
   button_config_save.set_name("button_config_save");
   connect_to_method(button_config_save.clicked, this, &Interface::on_button_config_save_clicked);
   button_config_adjust_colors.set_name("button_config_adjust_colors");
   connect_to_method(button_config_adjust_colors.clicked, this, &Interface::on_button_config_adjust_colors_clicked);
   hseparator62.set_name("hseparator62");
   hseparator63.set_name("hseparator63");
   hseparator64.set_name("hseparator64");
   hseparator65.set_name("hseparator65");
   clist_config_keyboard_type.set_name("clist_config_keyboard_type");
   clist_config_keyboard_type.set_column_title(0, "Key");
   clist_config_keyboard_type.set_column_title(1, "Key defs:");
   clist_config_keyboard_type.set_column_justification(0, GTK_JUSTIFY_CENTER);
   clist_config_keyboard_type.set_column_width(0, 23);
   clist_config_keyboard_type.set_column_width(1, 80);
   clist_config_keyboard_type.column_titles_show();
   connect_to_method(clist_config_keyboard_type.select_row, this, &Interface::on_clist_config_keyboard_type_select_row);
   scrolledwindow20.set_name("scrolledwindow20");
   scrolledwindow20.set_policy(GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);
   scrolledwindow20.add(clist_config_keyboard_type);
   table17.set_name("table17");
   table17.set_border_width(4);
   table17.attach(label234247, 0, 1, 0, 1, GTK_FILL, 0, 0, 0);
   table17.attach(*spinbutton__config_interface_repaint, 1, 2, 0, 1, GTK_FILL, 0, 0, 0);
   table17.attach(entry_main_font_name, 0, 1, 1, 2, GTK_FILL, GTK_EXPAND|GTK_FILL, 0, 0);
   entry_main_font_name.show();
   entry_main_font_name.changed.connect(slot(this,&Interface::on_entry_main_font_name_changed));

   Gtk::Button *button_main_ok_font = new Gtk::Button("Set Font");
   table17.attach(*button_main_ok_font, 1, 2, 1, 2, 0, 0, 0, 0);
   button_main_ok_font->show();
   button_main_ok_font->clicked.connect(slot(this,&Interface::on_button_main_ok_font_changed));
   Gtk::Button *button_main_font_list = new Gtk::Button("Browse Font List");
   table17.attach(*button_main_font_list, 0, 1, 2, 3, GTK_FILL, 0, 0, 0);
   button_main_font_list->show();
   button_main_font_list->clicked.connect(slot(this,&Interface::on_button_main_font_list_changed));
   table17.attach(hseparator61, 1, 2, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
   table17.attach(vseparator15, 4, 5, 0, 5, GTK_EXPAND|GTK_FILL, GTK_FILL, 0, 0);

   entry_main_song_path = new Gtk::Entry;
   entry_main_song_path->show();
   entry_main_data_path = new Gtk::Entry;
   entry_main_data_path->show();
   label_main_song_path = new Gtk::Label("Song Path");
   label_main_song_path->show();
   label_main_data_path = new Gtk::Label("Data Path");
   label_main_data_path->show();

   entry_main_song_path->changed.connect(slot(this,&Interface::on_entry_main_song_path_changed));
   entry_main_data_path->changed.connect(slot(this,&Interface::on_entry_main_data_path_changed));


   table17.attach(*entry_main_song_path, 0, 1, 3, 4, GTK_FILL, 0, 0, 0);
   table17.attach(*entry_main_data_path, 0, 1, 4, 5, GTK_FILL, 0, 0, 0);
   table17.attach(*label_main_song_path, 1, 2, 3, 4, GTK_FILL, 0, 0, 0);
   table17.attach(*label_main_data_path, 1, 2, 4, 5, GTK_FILL, 0, 0, 0);




//   table17.attach(vseparator16, 4, 5, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
 //  table17.attach(vseparator17, 4, 5, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
//   table17.attach(button_config_save, 5, 6, 0, 1, GTK_FILL, 0, 0, 0);

//HERE!
//   table17.attach(button_config_adjust_colors, 3, 4, 0, 1, GTK_FILL, 0, 0, 0);
//   table17.attach(hseparator62, 3, 4, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
//   table17.attach(hseparator63, 3, 4, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
//   table17.attach(hseparator64, 5, 6, 1, 2, GTK_FILL, GTK_FILL, 0, 0);
//   table17.attach(hseparator65, 5, 6, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
   table17.attach(scrolledwindow20, 2, 4, 0, 4, GTK_EXPAND|GTK_FILL, GTK_FILL, 0, 0);
   table17.attach(button_config_adjust_colors, 2, 4, 4, 5, GTK_FILL, 0, 0, 0);

   table17.attach(revset, 5, 6, 0, 5, 0, 0, 0);

   config_reverb_parms_label[0]=new Gtk::Label("Room");
   config_reverb_parms_label[1]=new Gtk::Label("Damp");
   config_reverb_parms_label[2]=new Gtk::Label("Wet");
   config_reverb_parms_label[3]=new Gtk::Label("Dry");
   config_reverb_parms_label[4]=new Gtk::Label("Width");
   revset.show();

   for (int i=0;i<5;i++) {

	table17.attach(*config_reverb_parms_label[i],6,7,i,i+1, GTK_EXPAND|GTK_FILL, GTK_FILL, 0, 0);
	config_reverb_parms_label[i]->show();
	config_reverb_parms_adj[i] = new Gtk::Adjustment(1, 0, 127, 10, 10, 0);
   	config_reverb_parms[i] = new Gtk::HScale(*config_reverb_parms_adj[i]);
   	config_reverb_parms[i]->set_digits(0);
	table17.attach(*config_reverb_parms[i],7, 8,i,i+1, GTK_EXPAND|GTK_FILL, GTK_FILL, 0, 0);
	config_reverb_parms[i]->show();
	config_reverb_parms_adj[i]->value_changed.connect(slot(this,&Interface::on_vscrollbar_config_reverb_changed));
    }
     		   	

   frame39.set_name("frame39");
   frame39.set_label_align(0, 0);
   frame39.set_shadow_type(GTK_SHADOW_ETCHED_IN);
   frame39.add(table17);
   vbox23.set_name("vbox23");
   vbox23.pack_start(frame36);
   vbox23.pack_start(frame39);
   clist_config_sound_driver_name.show();
   scrolledwindow18.show();
   hseparator56.show();
   hseparator57.show();
   checkbutton_config_16bits.show();
   checkbutton_config_stereo.show();
   label234243.show();
   button_config_sound_restart.show();
   button_config_sound_config.show();
   label234244.show();
   entry_config_sound_status.show();

   combo_config_frequency.show();
   table15.show();
   frame37.show();
   clist_config_mixer_proc.show();
   scrolledwindow19.show();
   label234246.show();
   spinbutton_config_virtual_channels->show();
   table16.show();
   frame38.show();
   hbox60.show();
   frame36.show();
   label234247.show();
   spinbutton__config_interface_repaint->show();
   hseparator58.show();
   hseparator59.show();
   hseparator60.show();
   hseparator61.show();
   vseparator15.show();
   vseparator16.show();
   vseparator17.show();
   button_config_save.show();
   button_config_adjust_colors.show();
   hseparator62.show();
   hseparator63.show();
   hseparator64.show();
   hseparator65.show();
   clist_config_keyboard_type.show();
   combo_config_buffersize.show();
   scrolledwindow20.show();
   table17.show();
   frame39.show();
   vbox23.show();
   labelbuffsize.show();
   notebook_main.append_page(vbox23, label19);

/* Callback connections */

	clist_instrments_names.select_row.connect(slot(this,&Interface::on_clist_instrments_names_select_row));
	clist_samples_list.select_row.connect(slot(this,&Interface::on_clist_samples_list_select_row));

/*SAMPLES SCREEN CALLBACKS*/
	spinbutton_samples_def_volume_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_def_volume_changed));
	spinbutton_samples_glb_volume_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_glb_volume_changed));
	spinbutton_samples_def_pan_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_def_pan_changed));
	spinbutton_samples_vibrato_speed_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_vibrato_speed_changed));
	spinbutton_samples_vibrato_depth_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_vibrato_depth_changed));
	spinbutton_samples_vibrato_rate_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_vibrato_rate_changed));

	spinbutton_samples_speed_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_speed_changed));
	spinbutton_samples_loop_begin_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_loop_begin_changed));
	spinbutton_samples_loop_end_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_loop_end_changed));
	spinbutton_samples_susloop_begin_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_susloop_begin_changed));
	spinbutton_samples_susloop_end_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_susloop_end_changed));
	entry_samples_samplename.changed.connect(slot(this,&Interface::on_entry_samples_samplename_changed));
	combo_samples_loop_type.get_entry()->changed.connect(slot(this,&Interface::on_entry_samples_loop_type_changed));
	combo_samples_susloop_type.get_entry()->changed.connect(slot(this,&Interface::on_entry_samples_sustain_loop_type_changed));

        {

		int i;

		for (i=0;i<Popup_Sample_Utils::ITEM_OPTION_MAX;i++) {

			sample_utils_popup.items[i]->activate.connect(bind<int>(slot(this,&Interface::on_popup_sample_edit_clicked),i));
		}
	}

        {

		int i;

		for (i=0;i<Popup_Instrument_Utils::ITEM_OPTION_MAX;i++) {

			instrument_utils_popup.items[i]->activate.connect(bind<int>(slot(this,&Interface::on_popup_instrument_edit_clicked),i));
		}
	}

/*INSTRUMENT SCREEN*/

	envelope_instruments_volume.button_press_event.connect(slot(this,&Interface::on_envelope_instruments_volume_clicked));
	envelope_instruments_volume.key_press_event.connect(slot(this,&Interface::on_envelope_instruments_volume_key_pressed));

	envelope_instruments_pan.button_press_event.connect(slot(this,&Interface::on_envelope_instruments_pan_clicked));
	envelope_instruments_pan.key_press_event.connect(slot(this,&Interface::on_envelope_instruments_pan_key_pressed));

	envelope_instruments_frequency.button_press_event.connect(slot(this,&Interface::on_envelope_instruments_frequency_clicked));
	envelope_instruments_frequency.key_press_event.connect(slot(this,&Interface::on_envelope_instruments_frequency_key_pressed));

        spinbutton_instruments_volume_envelope_loop_begin_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_volume_envelope_loop_begin_changed));
        spinbutton_instruments_volume_envelope_loop_end_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_volume_envelope_loop_end_changed));
        spinbutton_instruments_volume_envelope_susloop_begin_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_volume_envelope_susloop_begin_changed));
        spinbutton_instruments_volume_envelope_susloop_end_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_volume_envelope_susloop_end_changed));

	spinbutton_instruments_pan_envelope_loop_begin_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_pan_envelope_loop_begin_changed));
        spinbutton_instruments_pan_envelope_loop_end_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_pan_envelope_loop_end_changed));
        spinbutton_instruments_pan_envelope_susloop_begin_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_pan_envelope_susloop_begin_changed));
        spinbutton_instruments_pan_envelope_susloop_end_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_pan_envelope_susloop_end_changed));

	spinbutton_instruments_frequency_envelope_loop_begin_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_frequency_envelope_loop_begin_changed));
        spinbutton_instruments_frequency_envelope_loop_end_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_frequency_envelope_loop_end_changed));
        spinbutton_instruments_frequency_envelope_susloop_begin_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_frequency_envelope_susloop_begin_changed));
        spinbutton_instruments_frequency_envelope_susloop_end_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_frequency_envelope_susloop_end_changed));

	spinbutton_instruments_global_volume_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_global_volume_changed));
	spinbutton_instruments_volume_fadeout_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_volume_fadeout_changed));
	spinbutton_instruments_volume_swing_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_volume_swing_changed));

	spinbutton_instruments_pan_default_value_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_pan_default_value_changed));
	spinbutton_instruments_pan_pitch_center_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_pan_pitch_center_changed));
	spinbutton_instruments_pitch_pan_separation_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_pitch_pan_separation_changed));
	spinbutton_instruments_pan_swing_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_instruments_pan_swing_changed));

	checkbutton_instruments_pitch_envelope.clicked.connect(slot(this,&Interface::on_checkbutton_instruments_pitch_envelope_clicked));
	checkbutton_instruments_pitch_envelope_filter.clicked.connect(slot(this,&Interface::on_checkbutton_instruments_pitch_envelope_filter_clicked));

    //    clist_instrments_names.set_events(GDK_KEY_RELEASE_MASK);
	add_events(GDK_KEY_RELEASE_MASK);
	notebook2.add_events(GDK_KEY_RELEASE_MASK);
	//scrolledwindow2.add_events(GDK_KEY_RELEASE_MASK);

	clist_instrments_names.key_press_event.connect(slot(this,&Interface::on_instruments_piano_enabled_widgets_key_pressed));
	clist_instrments_names.key_release_event.connect(slot(this,&Interface::on_instruments_piano_enabled_widgets_key_released));

	clist_samples_list.key_press_event.connect(slot(this,&Interface::on_samples_piano_enabled_widgets_key_pressed));
	clist_samples_list.key_release_event.connect(slot(this,&Interface::on_samples_piano_enabled_widgets_key_released));
	clist_samples_list.set_button_actions(2,GTK_BUTTON_SELECTS);

	spinbutton_samples_base_note_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_base_note_changed));
	spinbutton_samples_finetune_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_samples_finetune_changed));

	key_press_event.connect(slot(this,&Interface::on_main_key_pressed));

/* VARIABLES SCREEN */

	spinbutton_variables_tempo_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_variables_tempo_changed));
	spinbutton_variables_speed_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_variables_speed_changed));
	spinbutton_variables_glb_volume_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_variables_glb_volume_changed));
	spinbutton_variables_mix_volume_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_variables_mix_volume_changed));
	spinbutton_variables_stereo_separation_adj->value_changed.connect(slot(this,&Interface::on_spinbutton_variables_stereo_separation_changed));
	text_variables_message.changed.connect(slot(this,&Interface::on_text_variables_changed));
	notebook_main.switch_page.connect(slot(this,&Interface::on_notebook_main_page_switch));


	key_release_event.connect(slot(this,&Interface::on_main_notebook_key_released));

        entry_main_song_name.set_max_length(25);
        entry_samples_samplename.set_max_length(25);
        entry_instrument_name.set_max_length(25);

	{	
			
	        Gtk::Pixmap *bf,*ff,*play,*stop,*play_pat,*play_cur,*help,*file;
		bf = new Gtk::Pixmap((gchar**)bw_xpm);
		bf->show();
		ff = new Gtk::Pixmap((gchar**)ff_xpm);
		ff->show();
		play = new Gtk::Pixmap((gchar**)play_xpm);
		play->show();
		stop = new Gtk::Pixmap((gchar**)stop_xpm);
		stop->show();
		play_pat = new Gtk::Pixmap((gchar**)play_pat_xpm);
		play_pat->show();
		play_cur = new Gtk::Pixmap((gchar**)play_cur_xpm);
		play_cur->show();
		help = new Gtk::Pixmap((gchar**)help_xpm);
		help->show();
		file = new Gtk::Pixmap((gchar**)file_xpm);
		file->show();

		button_main_play_prev_pattern.add(*bf);
		button_main_stop.add(*stop);

		button_main_play.add(*play);
		button_main_play_next_pattern.add(*ff);

		button_main_play_pattern.add(*play_pat);
		button_main_play_custom.add(*play_cur);
		button_main_help.add(*help);
	        button_main_file.add(*file);

		button_main_file.clicked.connect(slot(this,&Interface::on_button_main_file_clicked));
		button_main_file.show();

	}



}