/***************************************************************************
                          interface_update_main.cpp  -  description
                             -------------------
    begin                : Fri Jan 26 2001
    copyright            : (C) 2001 by Juan Linietsky
    email                : reduz@anime.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "interface.h"

void Interface::update_main_editing_entries() {

	char pat_string[8];
	char row_string[8];
	char speedtempo_string[8];
	char order_string[8];

	char ins_string[3]={0,0,0};
	char instrument_string[30];
	char octave[2];
	string insname;


	octave[1]=pat_string[7]=row_string[7]=instrument_string[30]=speedtempo_string[7]=order_string[7]=0;


	pat_string[0]=NUM_2_THIRD_CHAR(editor.get_current_pattern());
	pat_string[1]=NUM_2_SECOND_CHAR(editor.get_current_pattern());
	pat_string[2]=NUM_2_FIRST_CHAR(editor.get_current_pattern());
	pat_string[3]='/';
	pat_string[4]=NUM_2_THIRD_CHAR(song->get_patterns_used());
	pat_string[5]=NUM_2_SECOND_CHAR(song->get_patterns_used());
	pat_string[6]=NUM_2_FIRST_CHAR(song->get_patterns_used());


	row_string[0]=NUM_2_THIRD_CHAR(editor.get_cursor_y());
	row_string[1]=NUM_2_SECOND_CHAR(editor.get_cursor_y());
	row_string[2]=NUM_2_FIRST_CHAR(editor.get_cursor_y());
	row_string[3]='/';
	row_string[4]=NUM_2_THIRD_CHAR(song->get_pattern(editor.get_current_pattern())->get_length());
	row_string[5]=NUM_2_SECOND_CHAR(song->get_pattern(editor.get_current_pattern())->get_length());
	row_string[6]=NUM_2_FIRST_CHAR(song->get_pattern(editor.get_current_pattern())->get_length());


	speedtempo_string[0]=NUM_2_THIRD_CHAR(player->get_current_speed());
	speedtempo_string[1]=NUM_2_SECOND_CHAR(player->get_current_speed());
	speedtempo_string[2]=NUM_2_FIRST_CHAR(player->get_current_speed());
	speedtempo_string[3]='/';
	speedtempo_string[4]=NUM_2_THIRD_CHAR(player->get_current_tempo());
	speedtempo_string[5]=NUM_2_SECOND_CHAR(player->get_current_tempo());
	speedtempo_string[6]=NUM_2_FIRST_CHAR(player->get_current_tempo());

	order_string[0]=NUM_2_THIRD_CHAR(editor.orderlist_get_cursor_y());
	order_string[1]=NUM_2_SECOND_CHAR(editor.orderlist_get_cursor_y());
	order_string[2]=NUM_2_FIRST_CHAR(editor.orderlist_get_cursor_y());
	order_string[3]='/';
	order_string[4]=NUM_2_THIRD_CHAR(song->get_used_orders_amount());
	order_string[5]=NUM_2_SECOND_CHAR(song->get_used_orders_amount());
	order_string[6]=NUM_2_FIRST_CHAR(song->get_used_orders_amount());

	octave[0]=NUM_2_FIRST_CHAR(editor.get_default_octave());


	if (editor.get_instrument_mask_value()!=EMPTY_FIELD) {

		ins_string[0]='0'+(editor.get_instrument_mask_value()+1)/10;
		ins_string[1]='0'+(editor.get_instrument_mask_value()+1)%10;

		if (song->variables.use_instruments) {

        		insname=song->get_instrument(editor.get_instrument_mask_value())->name;
	
		} else {

        		insname=song->get_sample(editor.get_instrument_mask_value())->name;

		}
	} else {

		ins_string[0]='.';
		ins_string[1]='.';
		insname="......................";
	}


	insname="  "+insname;
	insname=ins_string+insname;
	entry_main_octave.set_text(octave);
	entry_main_pattern.set_text(pat_string);
        entry_main_order.set_text(order_string);
	entry_main_speed_tempo.set_text(speedtempo_string);
	entry_main_row.set_text(row_string);
	entry_main_instrument.set_text(insname.c_str());
	

//	instrument_string[0]=NUM_2_SECOND_CHAR(selected_instrument);


}

void Interface::update_main_all_entries() {
	
	string aux_string;
	int i;
	
	main_entries_updating_in_progress=true;


	update_main_editing_entries();
	

	entry_main_song_name.set_text(song->variables.name);


       	for (i=song->variables.filename.length()-1;i>=0;i--) {

		if ((song->variables.filename[i]!='/') && (song->variables.filename[i]!='\\')) {

                 	aux_string=song->variables.filename[i]+aux_string;
		} else {

			 break;
		}
	}


	entry_main_file_name.set_text(aux_string);

	main_entries_updating_in_progress=false;

}
