/***************************************************************************
                          mixer_procedure_raw.h  -  description
                             -------------------
    begin                : Wed Apr 18 2001
    copyright            : (C) 2001 by Juan Linietsky
    email                : reduz@anime.com.ar
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MIXER_PROCEDURE_RAW_H
#define MIXER_PROCEDURE_RAW_H


#include "mixer_procedure.h"
#include <stdio.h>
/**Raw nonintertpolated
  *@author Juan Linietsky

  */
/******************************
 mixer_procedure_raw.h
 ----------

raw mixing!
Lysander Lapine likes this.
********************************/


class Mixer_Procedure_Raw : public Mixer_Procedure {

        template<class Precision,class Depth >

        void mix_internal() {

        	MIXER_STEP_1_INIT
        	MIXER_STEP_2_LOOP_BEGIN
        	final_data = data_ptr[aux_index >> FRACBITS];
        	MIXER_STEP_3_CONVERT_TO_16BITS
	       	MIXER_STEP_3_BIS_PASS_FILTER
        	MIXER_STEP_4_MIX_TO_BUFFER_AND_EXIT
	}
	

public:

	Sint64 mix_mono();
	Sint64 mix_stereo();
	Sint64 mix_surround();


	Mixer_Procedure_Raw();
	~Mixer_Procedure_Raw();

	string get_name() { return "Raw"; };

	void register_sample(Sample_Data *p_sample) {};
	void unregister_sample(Sample_Data *p_sample) {};



};



#endif
