/***************************************************************************
                          sound_driver_diskwrite.h  -  description
                             -------------------
    begin                : Mon Mar 4 2002
    copyright            : (C) 2002 by red
    email                : red@server
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SOUND_DRIVER_DISKWRITE_H
#define SOUND_DRIVER_DISKWRITE_H

#include "sound_driver.h"
#include "file_writer.h"

/**
  *@author red
  */

class Sound_Driver_DiskWrite : public Sound_Driver  {

	enum {
	
		SAVE_BUFFER_SIZE = 512
	};
	
	Sint16 save_buffer[SAVE_BUFFER_SIZE];

	File_Writer writer;
	int head_len_pos;
	int data_len_pos;
	int written;
	bool finished_dump;
	bool began_saving;
	
public:
	
	void start_dump();
	void end_dump();
	


      	int get_mix_frequency();
        bool get_mix_stereo();
        bool get_mix_16bits();
        int get_mix_buffer_size();

	string get_name();

	int init();
	bool finish();
	bool is_active();
        bool update();


	Sound_Driver_DiskWrite();
	~Sound_Driver_DiskWrite();
};

#endif
